(* use this theory for tests before Build_Isac.thy has succeeded *)
theory Test_Theory imports "$ISABELLE_ISAC/Build_Isac"
begin                                                                            
ML_file "$ISABELLE_ISAC/BaseDefinitions/libraryC.sml"

section \<open>code for copy & paste ===============================================================\<close>
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
"~~~~~ fun xxx , args:"; val () = ();
"~~~~~ and xxx , args:"; val () = ();
"~~~~~ from fun xxx \<longrightarrow>fun yyy \<longrightarrow>fun zzz , return:"; val () = ();
"~~~~~ continue fun xxx"; val () = ();
(*if*) (*then*); (*else*); (*andalso*)  (*case*) (*of*);  (*return value*); (*in*) (*end*);
"xx"
^ "xxx"   (*+*) (*+++*) (*keep for continuing YYYYY*) (*isa*) (*isa2*) (**)
\<close> ML \<open> (*//----------- build fun XXXXX -----------------------------------------------------\\*)
(*//------------------ build fun XXXXX -----------------------------------------------------\\*)
(*\\------------------ build fun XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- build fun XXXXX -----------------------------------------------------//*)
val return_XXXXX = "XXXXX"
\<close> ML \<open> (*//----------- step into XXXXX -----------------------------------------------------\\*)
(*//------------------ step into XXXXX -----------------------------------------------------\\*)
\<close> ML \<open> (*||----------- contine XXXXX ---------------------------------------------------------*)
(*||------------------ contine XXXXX ---------------------------------------------------------*)
(*\\------------------ step into XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into XXXXX -----------------------------------------------------//*)
val "XXXXX" = return_XXXXX;

(* final test ... ----------------------------------------------------------------------------*)

\<close> ML \<open> (*//----------- inserted hidden code ------------------------------------------------\\*)
(*//------------------ inserted hidden code ------------------------------------------------\\*)
(*\\------------------ inserted hidden code ------------------------------------------------//*)
\<close> ML \<open> (*\\----------- inserted hidden code ------------------------------------------------//*)

\<close>
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>
text \<open>
  declare [[show_types]] 
  declare [[show_sorts]]
  find_theorems "?a <= ?a"
  
  print_theorems                                    
  print_facts
  print_statement ""
  print_theory
  ML_command \<open>Pretty.writeln prt\<close>
  declare [[ML_print_depth = 999]]                 
  declare [[ML_exception_trace]]
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>

\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====maxi 150a-add-given-Maximum.sml ==============================================\<close>
ML \<open>
\<close> ML \<open>
(* Title:  "Minisubpbl/150a-add-given-Maximum.sml"
   Author: Walther Neuper 1105
   (c) copyright due to lincense terms.

ATTENTION: the file creates buffer overflow if copied in one piece !

Note: This test --- steps into me --- more than once, to a somewhat extreme extent;
  in order not to get lost while working in Test_Some etc, 
  re-introduce  ML (*--- step into XXXXX ---*) and Co.
  and use Sidekick for orientation.
  Nesting is indicated by  /---   //--   ///-  at the left margin of the comments.
*)

open Ctree;
open Pos;
open TermC;
open Istate;
open Tactic;
open Pre_Conds;
open I_Model;
open P_Model
open Rewrite;
open Step;
open LItool;
open LI;
open Test_Code
open Specify
open ME_Misc

val (_(*example text*),
  (model as ("Constants [r = (7::real)]" :: "Maximum A" :: "AdditionalValues [u, v]" :: 
     "Extremum (A = 2 * u * v - u \<up> 2)" :: 
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" :: 
     "SideConditions [((u::real) / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" :: 
     "SideConditions [(u::real) / 2 = r * sin \<alpha>, 2 / v = r * cos \<alpha>]" ::
(*---------------------------------------------,(v::real) / 2 = r * cos \<alpha>]" --- ERROR in example*)
     "FunctionVariable a" :: "FunctionVariable b" :: "FunctionVariable \<alpha>" :: 
     "Domain {0 <..< r}" :: "Domain {0 <..< r}" :: "Domain {0 <..< \<pi> / 2}" ::
     "ErrorBound (\<epsilon> = (0::real))" :: []), 
   refs as ("Diff_App", 
     ["univariate_calculus", "Optimisation"],
     ["Optimisation", "by_univariate_calculus"])))
  = Store.get (Know_Store.get_expls @{theory}) ["Diff_App-No.123a"] ["Diff_App-No.123a"];

\<close> ML \<open>
val c = [];
val return_init_calc = 
 Test_Code.init_calc @{context} [(model, refs)]; (*val Model_Problem = nxt;*)
\<close> ML \<open> (*/------------ step into init_calc -------------------------------------------------\\*)
(*/------------------- step into init_calc -------------------------------------------------\\*)
"~~~~~ fun init_calc , args:"; val (ctxt, [(model, refs as (thy_id, _, _))]) =
  (@{context}, [(model, refs)]);
\<close> ML \<open>
    val thy = thy_id |> ThyC.get_theory ctxt
\<close> ML \<open>
    val ((pt, p), tacis) = Step_Specify.initialise' thy (model, refs)
\<close> ML \<open>
	  val tac = case tacis of [] => Tactic.Empty_Tac | _ => (#1 o hd) tacis
\<close> ML \<open>
	  val f = 
           TESTg_form ctxt (pt,p);
\<close> ML \<open>
"~~~~~ fun TESTg_form , args:"; val (ctxt, ptp) = (ctxt, (pt,p));
\<close> ML \<open>
    val (form, _, _) =
   ME_Misc.pt_extract ctxt ptp
\<close> ML \<open>
"~~~~~ fun pt_extract , args:"; val (ctxt, (pt, (p, p_ as Pbl(*Frm,Pbl*)))) = (ctxt, ptp);
\<close> ML \<open>
        val ppobj = Ctree.get_obj I pt p
\<close> ML \<open>
        val f = if Ctree.is_pblobj ppobj then pt_model ppobj p_ else Ctree.get_obj pt_form pt p;
\<close> ML \<open>
            (*if*) Ctree.is_pblobj ppobj (*then*);
\<close> ML \<open>
           pt_model ppobj p_ ;
\<close> ML \<open> (*new...*)
"~~~~~ fun pt_model , args:"; val ((Ctree.PblObj {probl, spec, origin = (_, spec', hdl), ctxt, ...}), Pbl_) =
  (ppobj, p_);
\<close> ML \<open>
      val (_, pI, _) = Ctree.get_somespec' spec spec';
\<close> ML \<open>
(*    val where_ = if pI = Problem.id_empty then []*)
\<close> ML \<open>
               (*if*) pI = Problem.id_empty (*else*);
\<close> ML \<open>
	          val {where_rls, where_, model, ...} = Problem.from_store ctxt pI
\<close> ML \<open>
	          val (_, where_) = 
 Pre_Conds.check_OLD ctxt where_rls where_
              (model, I_Model.OLD_to_TEST probl);
\<close> ML \<open>
"~~~~~ fun check_OLD , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (model, I_Model.OLD_to_TEST probl));
\<close> ML \<open>
      val (_, (** )_( **)env_model(**), (env_subst, env_eval)) =
           of_max_variant model_patt i_model;
\<close> ML \<open>
(*maxi*)val "[]" = env_model |> Subst.to_string @{context}
(*maxi*)val "[]" = env_subst |> Subst.to_string @{context}
\<close> ML \<open>
"~~~~~ fun of_max_variant , args:"; val (_, []) = (model_patt, i_model);
(*\------------------- step into init_calc -------------------------------------------------//*)
\<close> ML \<open> (*\------------ step into init_calc -------------------------------------------------//*)
\<close> ML \<open>
val (p,_,f,nxt,_,pt) = return_init_calc;

\<close> ML \<open>
(*+*)val PblObj {ctxt, probl, ...} = get_obj I pt [];
(*+*)Proof_Context.theory_of ctxt (*= {Pure, .., Diff_App}*);
(*+*)val Free ("r", Type ("Real.real", [])) = Syntax.read_term ctxt "r"
(*+*)val [] = probl

\<close> ML \<open> (*ERROR penv_value: no values in 'Constants*)
val return_me_Model_Problem = 
           me nxt p c pt; val Add_Given "Constants [r = 7]" = #4 return_me_Model_Problem;
\<close> ML \<open> (*/------------ step into me Model_Problem ------------------------------------------\\*)
(*/------------------- step into me Model_Problem ------------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, (p:Pos.pos'), (_:Test_Code.NEW), (pt:Ctree.ctree)) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p
val return_by_tactic = case
      Step.by_tactic tac (pt,p) of
		    ("ok", (_, _, ptp)) => ptp;
\<close> ML \<open> (*//----------- step into by_tactic -------------------------------------------------\\*)
(*//------------------ step into by_tactic -------------------------------------------------\\*)
"~~~~~ fun by_tactic , args:"; val (tac, (ptp as (pt, p))) = (tac, (pt,p));
val Applicable.Yes tac' = (*case*)
      Step.check tac (pt, p) (*of*);
(*+*)val Model_Problem' _ = tac';
"~~~~~ fun check , args:"; val (tac, (ctree, pos)) = (tac, (pt, p));
  (*if*) Tactic.for_specify tac (*then*);

Specify_Step.check tac (ctree, pos);
"~~~~~ fun check , args:"; val (Tactic.Model_Problem, (pt, pos as (p, _))) =
  (tac, (ctree, pos));
        val (o_model, pI', ctxt) = case Ctree.get_obj I pt p of
          Ctree.PblObj {origin = (o_model, (_, pI', _), _), ctxt, ...} => (o_model, pI', ctxt)
	      val {model = model_patt, ...} = Problem.from_store (Ctree.get_ctxt pt pos) pI'
	      val pbl = I_Model.init_TEST o_model model_patt;

val return_check =
    Applicable.Yes (Tactic.Model_Problem' (pI', I_Model.TEST_to_OLD pbl, []));
(*\\------------------ step into by_tactic -------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into by_tactic -------------------------------------------------//*)
val (pt, p) = return_by_tactic;

\<close> ML \<open>
val return_do_next = (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
\<close> ML \<open> (*//----------- step into do_next ---------------------------------------------------\\*)
(*//------------------ step into do_next ---------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val (((ip as (_,p_)):pos'), ((ptp as (pt,p), tacis):Calc.state_pre)) =
  (p, ((pt, e_pos'),[]));
\<close> ML \<open>
(*+*)val Pbl = p_
\<close> ML \<open>
    val pIopt = get_pblID (pt,ip);
    (*if*) ip = ([],Res); (* = false*)
      val _ = (*case*) tacis (*of*);
      val SOME _ = (*case*) pIopt (*of*);

\<close> ML \<open>
    val ("ok", ([(Add_Given "Constants [r = 7]", _, _)], [], _)) =
      Step.switch_specify_solve p_ (pt, ip);
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
\<close> ML \<open>
      (*if*) Pos.on_specification ([], state_pos) (*then*);

\<close> ML \<open>
    val ("ok", ([(Add_Given "Constants [r = 7]", _, _)], [], _)) =
      Step.specify_do_next (pt, input_pos);
\<close> ML \<open> (*///---------- step into specify_do_next -------------------------------------------\\*)
(*///----------------- step into specify_do_next -------------------------------------------\\*)
"~~~~~ fun specify_do_next , args:"; val (ptp as (pt, (p, p_))) = (pt, input_pos);

\<close> ML \<open>
(*  val (_, (p_', tac)) =*)
val return_find_next_step = (*keep for continuing specify_do_next*)
   Specify.find_next_step ptp;
\<close> ML \<open> (*////--------- step into find_next_step --------------------------------------------\\*)
(*////---------------- step into find_next_step --------------------------------------------\\*)
"~~~~~ fun find_next_step , args:"; val ((pt, pos as (_, p_))) = (ptp);
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos;
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
        (*if*) p_ = Pos.Pbl (*then*);

   Specify.for_problem ctxt oris (o_refs, refs) (pbl, met);
\<close> ML \<open> (*/////-------- step into for_problem -----------------------------------------------\\*)
(*/////--------------- step into for_problem -----------------------------------------------\\*)
"~~~~~ fun for_problem , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met))
  = (ctxt, oris, (o_refs, refs), (pbl, met));
    val cdI = if dI = ThyC.id_empty then dI' else dI;
    val cpI = if pI = Problem.id_empty then pI' else pI;
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = pbt, where_rls, where_, ...} = Problem.from_store ctxt cpI;
    val {model = mpc, ...} = MethodC.from_store ctxt cmI;

\<close> ML \<open> (*//----------- adhoc inserted fun check_OLD ----------------------------------------\\*)
(*//------------------ adhoc inserted fun check_OLD ----------------------------------------\\*)

(*T_TESTold* )
fun all_lhs_atoms ts = fold (curry and_) (map (fn t =>
  if can TermC.lhs t then TermC.is_atom (TermC.lhs t) else false) ts) true
( *T_TEST*)
fun all_lhs_atoms ts = fold (curry and_) (map (fn t =>
  if can TermC.lhs t andalso not (TermC.is_num (TermC.lhs t))
  then TermC.is_atom (TermC.lhs t)
  else false) ts) true
(*T_TESTnew*)

(*T_TESTold* )
fun handle_lists id (descr, ts) =
  if Model_Pattern.is_list_descr descr
  then if length ts > 1         (*list with more than 1 element needs to collect by [.., .., ..]*)
    then [(id, TermC.list2isalist (Model_Pattern.typ_of_element descr) ts)] (*AdditValues [u, v]*)
    else if TermC.is_atom (Library.the_single ts)
      then [(id, Library.the_single ts)]                                     (* solutions L, ...*)
      else [(id, TermC.list2isalist (Model_Pattern.typ_of_element descr) ts)](*Constants [r = 7]*)
  else [(id, Library.the_single ts)]                           (* solveFor x, Extremum (A = ...)*)
( *T_TEST***)
fun handle_lists id (descr, ts) =
  if Model_Pattern.is_list_descr descr
  then if length ts > 1         (*list with more than 1 element needs to collect by [.., .., ..]*)
    then if TermC.is_list (hd ts) (*---broken elementwise input to lists---*)
      then [(id, TermC.list2isalist (Model_Pattern.typ_of_element descr) (map TermC.the_single ts))]
      else [(id, TermC.list2isalist (Model_Pattern.typ_of_element descr) ts)] (*AdditValues [u, v]*)
    else if TermC.is_atom (Library.the_single ts)
      then [(id, Library.the_single ts)]                                     (* solutions L, ...*)
      else [(id, TermC.list2isalist (Model_Pattern.typ_of_element descr) ts)](*Constants [r = 7]*)
  else [(id, Library.the_single ts)]                           (* solveFor x, Extremum (A = ...)*)
(*T_TESTnew*)
;
handle_lists: term -> descriptor * term list -> (term * term) list;

fun mk_env_model _ (Model_Def.Cor_TEST ((_, []), _)) = []
  | mk_env_model id (Model_Def.Cor_TEST ((descr, ts), _)) = 
(*T_TEST.150* )
    if Model_Pattern.is_list_descr descr 
    then [(id, TermC.list2isalist (Model_Pattern.typ_of_element descr) ts)]
    else [(id, hd ts)]
( *T_TEST*)
    handle_lists id (descr, ts)
(*T_TEST.100*)
  | mk_env_model _ (Model_Def.Syn_TEST _) = [] (*TODO handle correct list elements*)
  | mk_env_model _ (Model_Def.Inc_TEST ((_, []), _)) = []
  | mk_env_model id (Model_Def.Inc_TEST ((descr, ts), _)) = 
(*T_TEST.150* )
    if Model_Pattern.is_list_descr descr 
    then [(id, TermC.list2isalist (Model_Pattern.typ_of_element descr) ts)]
    else [(id, hd ts)]
( *T_TEST*)
    handle_lists id (descr, ts)
(*T_TEST.100*)
  | mk_env_model _ (Model_Def.Sup_TEST _) = []
;
mk_env_model: term -> Model_Def.i_model_feedback_TEST -> Env.T;

val (id, (descr, ts)) = (@{term "v_v'i'::bool list"}, (@{term solutions}, [@{term "L::bool list"}]));
is_atom (Library.the_single [@{term "r = (7::real)"}]);

(*  vvvvvvvvvvvv-- REPLACES mk_env_subst_DEL, THUS THE LATTER IS UNCHANGED*)
fun make_env_model equal_descr_pairs =
  map (fn ((_, (_, id)), (_, _, _, _, (feedb, _)))
        => (mk_env_model id feedb)) equal_descr_pairs
  |> flat
;
make_env_model: (Model_Pattern.single * Model_Def.i_model_single_TEST) list -> Env.T;

fun switch_type_TEST descr [] = descr
  | switch_type_TEST (Free (id_string, _)) ts =
    Free (id_string, ts |> hd |> TermC.lhs |> type_of)
  | switch_type_TEST descr _ = raise ERROR ("switch_type_TEST undefined argument " ^
      quote (UnparseC.term (ContextC.for_ERROR ()) descr))
;
switch_type_TEST: descriptor -> term list -> descriptor;

(*T_TESTold* )
fun discern_typ _ (_, []) = []
  | discern_typ id (descr, ts) =
(*TODO.md "review (descriptor, ts)" REMOVE--------------------------------------\*)
    let
      val ts = if Model_Pattern.is_list_descr descr andalso TermC.is_list (hd ts)
        then TermC.isalist2list (hd ts)
        else ts
    in
(*TODO.md "review (descriptor, ts)" REMOVE--------------------------------------/*)
  if Model_Pattern.typ_of_element descr = HOLogic.boolT
    andalso ts |> map TermC.lhs |> all_atoms
  then
    if length ts > 1
    then raise ERROR "model items of type 'bool' in lists with 'lengt ts > 1' NOT YET IMPLEMENTED"
    else [((switch_type_TEST id ts, TermC.lhs (hd ts)), 
           (TermC.lhs (hd ts), TermC.rhs (hd ts)))]
  else []
(*TODO.md "review (descriptor, ts)" REMOVE--------------------------------------\*)
    end
(*TODO.md "review (descriptor, ts)" REMOVE--------------------------------------/*)
( *T_TEST*)
fun discern_typ _ (_, []) = []
  | discern_typ id (descr, ts) =
(*TODO.md "review (descriptor, ts)" REMOVE--------------------------------------\*)
    let
      val ts = if Model_Pattern.is_list_descr descr
        then if TermC.is_list (hd ts)
          then ts |> map TermC.isalist2list |> flat
          else ts
        else ts
    in
(*TODO.md "review (descriptor, ts)" REMOVE--------------------------------------/*)
  if Model_Pattern.typ_of_element descr = HOLogic.boolT andalso all_lhs_atoms ts
  then
    if length ts > 1
    then (writeln "model items of type 'bool' in lists with 'lengt ts > 1' NOT YET IMPLEMENTED";
      [])
    else [((switch_type_TEST id ts, TermC.lhs (hd ts)), 
           (TermC.lhs (hd ts), TermC.rhs (hd ts)))]
  else []
(*TODO.md "review (descriptor, ts)" REMOVE--------------------------------------\*)
    end
(*TODO.md "review (descriptor, ts)" REMOVE--------------------------------------/*)
;
discern_typ: term -> descriptor * term list -> ((term * term) * (term * term)) list;
(*T_TESTnew*)

fun discern_feedback id (Model_Def.Cor_TEST ((descr, ts), _)) = discern_typ id (descr, ts)
  | discern_feedback _ (Model_Def.Syn_TEST _) = [] (*TODO: handle correct elements*)
  | discern_feedback id (Model_Def.Inc_TEST ((descr, ts), _)) = discern_typ id (descr, ts)
  | discern_feedback _ (Model_Def.Sup_TEST _) = []
;
discern_feedback: term -> I_Model.feedback_TEST -> ((term * term) * (term * term)) list;

fun make_envs_preconds equal_givens =
  map (fn ((_, (_, id)), (_, _, _, _, (feedb, _))) => discern_feedback id feedb) equal_givens
  |> flat
;
make_envs_preconds: (Model_Pattern.single * I_Model.single_TEST) list ->
    ((term * term) * (term * term)) list;

(*T_TESTold* )
fun of_max_variant model_patt i_model =
( *T_TEST*)
fun of_max_variant _ [] = ([], [], ([], []))
  | of_max_variant model_patt i_model =
(*T_TESTnew*)
  let
    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (cnt_corrects) variants_separated
    val sum_variant_s = arrange_args1 sums_corr (1, all_variants)
    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
    val equal_descr_pairs = map (get_equal_descr i_model) model_patt |> flat
(*T_TESTold* )
    val env_subst = mk_env_subst_DEL equal_descr_pairs
    val env_eval = mk_env_eval_DEL i_model_max
  in
    (i_model_max, env_subst, env_eval)
  end
( *T_TEST*)
    val env_model = make_env_model equal_descr_pairs
    val equal_givens = filter (fn ((m_field, _), _) => m_field = "#Given") equal_descr_pairs
    val subst_eval_list = make_envs_preconds equal_givens
    val (env_subst, env_eval) = split_list subst_eval_list
  in
    (i_model_max, env_model, (env_subst, env_eval))
  end
(*T_TESTnew*)
;
of_max_variant: Model_Pattern.T -> Model_Def.i_model_TEST ->
       Model_Def.i_model_TEST * Env.T * (env_subst * env_eval);

fun check_OLD _ _ [] _  = (true, [])
  | check_OLD ctxt where_rls pres (model_patt, i_model) =
    let
(*T_TESTold* )
      val (env_subst, env_eval) = sep_variants_envs_OLD model_patt i_model
( *NEW*)  
      val (_, env_model, (env_subst, env_eval)) = of_max_variant model_patt i_model
(*NEW*)
      val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)
      val evals = map (eval ctxt where_rls) full_subst
    in
      (foldl and_ (true, map fst evals), pres_subst_other)
    end
;
check_OLD: Proof.context -> Rule_Def.rule_set -> term list -> Model_Pattern.T * I_Model.T_TEST ->
  checked;

\<close> ML \<open>
\<close> ML \<open>
(*T_TESTold*)
fun check_from_store ctxt where_rls pres env_subst env_eval =
  let
    val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
    val full_subst = map (fn (bool, t) => (bool, subst_atomic env_eval t)) pres_subst
    val evals = map (eval ctxt where_rls) full_subst
  in
    (foldl and_ (true, map fst evals), pres_subst)
  end
(*T_TEST*)
fun check_envs_TEST ctxt where_rls where_ (env_model, (env_subst, env_eval)) =
  let
      val pres_subst = map (TermC.subst_atomic_all env_subst) where_;
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)
      val evals = map (eval ctxt where_rls) full_subst
  in
      (foldl and_ (true, map fst evals), pres_subst_other)
  end
;
  check_envs_TEST: Proof.context -> Rule_Set.T -> unchecked -> Env.T * (env_subst * env_eval)
    -> checked
\<close> ML \<open>
(*T_TESTnew*)
\<close> ML \<open>
\<close> ML \<open>
(*\\------------------ adhoc inserted fun check_OLD ----------------------------------------//*)
\<close> ML \<open> (*\\----------- adhoc inserted fun check_OLD ----------------------------------------//*)
\<close> ML \<open> (*ERROR mk_env not reasonable for "Inc_TEST Constants [] [__=__, __=__]"*)
    val return_check_OLD =
           check_OLD ctxt where_rls where_ (pbt, I_Model.OLD_to_TEST pbl);
\<close> ML \<open> (*//////------- step into check_OLD -------------------------------------------------\\*)
(*//////-------------- step into check_OLD -------------------------------------------------\\*)
"~~~~~ fun check_OLD , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (pbt, I_Model.OLD_to_TEST pbl));
\<close> ML \<open>
      val return_of_max_variant =
           of_max_variant model_patt i_model;
\<close> ML \<open> (*///// //----- step into of_max_variant --------------------------------------------\\*)
(*///// //------------ step into of_max_variant --------------------------------------------\\*)
"~~~~~ fun of_max_variant , args:"; val (model_patt, i_model) =
  (model_patt, i_model);

(*with OLD code* )
(*+*)val "[\n(0, [], false ,#Given, (Inc_TEST Constants [__=__, __=__], Position.T)), \n(0, [], false ,#Find, (Inc_TEST Maximum __, Position.T)), \n(0, [], false ,#Find, (Inc_TEST AdditionalValues [__, __], Position.T)), \n(0, [], false ,#Relate, (Inc_TEST Extremum (__=__), Position.T)), \n(0, [], false ,#Relate, (Inc_TEST SideConditions [__=__, __=__], Position.T))]"
  = i_model |> I_Model.to_string_TEST @ {context}
( *with OLD code*)
\<close> ML \<open> (*with NEW code*)
(*+*)val "[\n(1, [1, 2, 3], false ,#Given, (Inc_TEST Constants [] [__=__, __=__], Position.T)), \n(2, [1, 2, 3], false ,#Find, (Inc_TEST Maximum __, Position.T)), \n(3, [1, 2, 3], false ,#Find, (Inc_TEST AdditionalValues [] [__, __], Position.T)), \n(4, [1, 2, 3], false ,#Relate, (Inc_TEST Extremum (__=__), Position.T)), \n(5, [1, 2], false ,#Relate, (Inc_TEST SideConditions [] [__=__, __=__], Position.T))]"
 = i_model |> I_Model.to_string_TEST @{context}
\<close> ML \<open>
    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (cnt_corrects) variants_separated
    val sum_variant_s = arrange_args1 sums_corr (1, all_variants)
\<close> ML \<open> (*with NEW code*)
(*+*)val [(0, 1), (0, 2), (0, 3)] = sum_variant_s
\<close> ML \<open>
    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
    val equal_descr_pairs = map (get_equal_descr i_model) model_patt |> flat
\<close> ML \<open>
(*for building make_env_s -------------------------------------------------------------------\*)
(*!!!*) val ("#Given", (descr, term), pos) =
  Model_Pattern.split_descriptor ctxt ("#Given", @{term "Constants [r = (7::real)]"}, Position.none)
(*!!!*) val patt = equal_descr_pairs |> hd |> #1
(*!!!*)val equal_descr_pairs =
  (patt,
  (1, [1, 2, 3], true, "#Given", (Cor_TEST ((descr, (*!*)TermC.isalist2list(*!*) term), 
                                                     (TermC.empty, [])), pos)))
  :: tl equal_descr_pairs
(*for building make_env_s -------------------------------------------------------------------/*)

\<close> ML \<open>
    val env_model = make_env_model equal_descr_pairs;
\<close> ML \<open> (*///// ///---- step into make_env_model --------------------------------------------\\*)
(*///// ///----------- step into make_env_model --------------------------------------------\\*)
"~~~~~ fun make_env_model , args:"; val (equal_descr_pairs) = (equal_descr_pairs);

val xxx = (fn ((_, (_, id)), (_, _, _, _, (feedb, _)))
       => (mk_env_model id feedb));
\<close> ML \<open>
val ((_, (_, id)), (_, _, _, _, (feedb, _))) = nth 4 equal_descr_pairs;
\<close> ML \<open> (*\\\\\ \\\---- step into make_env_model --------------------------------------------//*)
(*\\\\\ \\\----------- step into make_env_model --------------------------------------------//*)
\<close> ML \<open> (*||||| ||----- contine of_max_variant ------------------------------------------------*)
(*||||| ||------------ contine of_max_variant ------------------------------------------------*)

\<close> ML \<open> (*new on 15.7.*)
    val equal_givens = filter (fn ((m_field, _), _) => m_field = "#Given") equal_descr_pairs
\<close> ML \<open>
    val subst_eval_list = make_envs_preconds equal_givens
\<close> ML \<open>
val return_make_envs_preconds =
           make_envs_preconds equal_givens;
\<close> ML \<open> (*///// ///---- step into make_envs_preconds ----------------------------------------\\*)
(*///// ///----------- step into make_envs_preconds ----------------------------------------\\*)
"~~~~~ fun make_envs_preconds , args:"; val (equal_givens) = (equal_givens);
\<close> ML \<open>
val xxx = (fn ((_, (_, id)), (_, _, _, _, (feedb, _))) => discern_feedback id feedb)
;
xxx: (Model_Pattern.single * I_Model.single_TEST) -> ((term * term) * (term * term)) list;
\<close> ML \<open>
val return_discern_feedback =
           discern_feedback id feedb;
\<close> ML \<open>
(*nth 1 equal_descr_pairs* )
"~~~~~ fun discern_feedback , args:"; val (id, (Model_Def.Cor_TEST ((descr, ts), _))) = (id, feedb);
( *nth 2 equal_descr_pairs*)
"~~~~~ fun discern_feedback , args:"; val (id, (Model_Def.Inc_TEST ((descr, ts), _))) = (id, feedb);
(**)
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
(*nth 1 equal_descr_pairs* )
(*+*)val [((Const ("fixes", typ1), Free ("r", typ2)),
           (Free ("r", typ3), value))] = return_discern_feedback
(*+*)val true = typ1 = typ2
(*+*)val true = typ3 = HOLogic.realT
(*+*)val "7" = UnparseC.term @{context} value
( *nth 2 equal_descr_pairs*)
\<close> ML \<open>
(*+*)val [] = return_discern_feedback
(**)
\<close> ML \<open>
val return_discern_typ =
           discern_typ id (descr, ts);
"~~~~~ fun discern_typ , args:"; val (id, (descr, ts)) = (id, (descr, ts));
\<close> ML \<open>
(*nth 1 equal_descr_pairs* )
(*+*)val [((Const ("fixes", typ1), Free ("r", typ2)),
           (Free ("r", typ3), value))] = return_discern_typ
(*+*)val true = typ1 = typ2
(*+*)val true = typ3 = HOLogic.realT
(*+*)val "7" = UnparseC.term @{context} value
( *nth 2 equal_descr_pairs*)
(*+*)val [] = return_discern_typ;
(**)
\<close> ML \<open>
           switch_type_TEST id ts;
\<close> ML \<open>
"~~~~~ fun switch_type_TEST , args:"; val (Const (descr_string, _), ts) = (descr, ts);
\<close> ML \<open>
\<close> ML \<open>
(*nth 1 equal_descr_pairs* )
val return_switch_type_TEST = Const (descr_string, ts |> hd |> TermC.lhs |> type_of)

(*+*)val Const ("Input_Descript.Constants", typ) = return_switch_type_TEST
(*+*)val Type ("Real.real", []) = typ
( *nth 2 equal_descr_pairs*)
(*+*)val return_switch_type_TEST = descr
(**)
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open> (*\\\\\ \\\---- step into make_envs_preconds ----------------------------------------//*)
(*\\\\\ \\\----------- step into make_envs_preconds ----------------------------------------//*)
\<close> ML \<open> (*||||| ||----- contine of_max_variant ------------------------------------------------*)
(*||||| ||------------ contine of_max_variant ------------------------------------------------*)
    val subst_eval_list = make_envs_preconds equal_givens
\<close> ML \<open>
    val (env_subst, env_eval) = split_list subst_eval_list
\<close> ML \<open>
(*maxi*)val "[\"\n(fixes, [r = 7])\"]" = env_model |> Subst.to_string @{context}
(*maxi*)val "[\"\n(fixes, r)\"]" = env_subst |> Subst.to_string @{context}
\<close> ML \<open>
val return_of_max_variant = (i_model_max, env_model, (env_subst, env_eval)); (*GOON*)
(*\\\\\ \\------------ step into of_max_variant --------------------------------------------//*)
\<close> ML \<open> (*\\\\\ \\----- step into of_max_variant --------------------------------------------//*)
      val (i_model_max, env_model, (env_subst, env_eval)) = return_of_max_variant
\<close> ML \<open>
(*!!!/----- we had a helpful argument for constructing env_model and (env_subst, env_eval)---\*)
      val (i_max_variant, env_model, (env_subst, env_eval)) = (i_model_max, [], ([], []))
(*!!!\----- we had a helpful argument for constructing env_model and (env_subst, env_eval)---/*) 
\<close> ML \<open> (*||||||------- contine check_OLD -----------------------------------------------------*)
(*||||||-------------- contine check_OLD -----------------------------------------------------*)
\<close> ML \<open>
      val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)
      val evals = map (eval ctxt where_rls) full_subst
val return_ = (i_model_max, env_subst, env_eval)
(*\\\\\\\------------- step into check_OLD -------------------------------------------------//*)
\<close> ML \<open> (*\\\\\\------- step into check_OLD -------------------------------------------------//*)
\<close> ML \<open>
val (preok, _) = return_check_OLD;
\<close> ML \<open> (*|||||-------- contine for_problem ---------------------------------------------------*)
(*|||||--------------- contine for_problem ---------------------------------------------------*)
    (*if*) dI' = ThyC.id_empty andalso dI = ThyC.id_empty (*else*);
      (*if*) pI' = Problem.id_empty andalso pI = Problem.id_empty (*else*);
val NONE =
     (*case*) find_first (I_Model.is_error o #5) pbl (*of*);

        (*case*)
   Specify.item_to_add (ThyC.get_theory ctxt
            (if dI = ThyC.id_empty then dI' else dI)) oris pbt pbl (*of*);
"~~~~~ fun item_to_add , args:"; val (thy, oris, _, itms)
  = ((ThyC.get_theory ctxt (if dI = ThyC.id_empty then dI' else dI)), oris, pbt, pbl);
      fun false_and_not_Sup (_, _, false, _, I_Model.Sup _) = false
        | false_and_not_Sup (_, _, false, _, _) = true
        | false_and_not_Sup _ = false

      val v = if itms = [] then 1 else Pre_Conds.max_variant itms
      val vors = if v = 0 then oris
        else filter ((fn variant =>
            fn (_, variants, m_field, _, _) => member op= variants variant andalso m_field <> "#undef")
          v) oris

(*+*)val "[\n(1, [\"1\", \"2\", \"3\"], #Given, Constants, [\"[r = 7]\"]), \n(2, [\"1\", \"2\", \"3\"], #Find, Maximum, [\"A\"]), \n(3, [\"1\", \"2\", \"3\"], #Find, AdditionalValues, [\"[u]\", \"[v]\"]), \n(4, [\"1\", \"2\", \"3\"], #Relate, Extremum, [\"A = 2 * u * v - u \<up> 2\"]), \n(5, [\"1\", \"2\"], #Relate, SideConditions, [\"[(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]\"])]"
(*+*)  = vors |> O_Model.to_string @{context}

      val vits = if v = 0 then itms               (* because of dsc without dat *)
  	    else filter ((fn variant =>
            fn (_, variants, _, _, _) => member op= variants variant)
          v) itms;                                (* itms..vat *)

      val icl = filter false_and_not_Sup vits;    (* incomplete *)

      (*if*) icl = [] (*else*);
(*+*)val "[\n(1 ,[1, 2, 3] ,false ,#Given ,Inc Constants [] ,(Constants, [])), \n(2 ,[1, 2, 3] ,false ,#Find ,Inc Maximum ,(Maximum, [])), \n(3 ,[1, 2, 3] ,false ,#Find ,Inc AdditionalValues [] ,(AdditionalValues, [])), \n(4 ,[1, 2, 3] ,false ,#Relate ,Inc Extremum ,(Extremum, [])), \n(5 ,[1, 2] ,false ,#Relate ,Inc SideConditions [] ,(SideConditions, []))]"
(*+*)  = icl |> I_Model.to_string @{context}
(*+*)val "(1 ,[1, 2, 3] ,false ,#Given ,Inc Constants [] ,(Constants, []))"
(*+*)  = hd icl |> I_Model.single_to_string @{context}

(*++*)val feedback = (fn (_, _, _, _, feedback) => feedback) (hd icl)
(*++*)val Const ("Input_Descript.Constants", _) = I_Model.descriptor feedback
(*++*)val [] = I_Model.o_model_values feedback

(*+*)val "[\n(1, [\"1\", \"2\", \"3\"], #Given, Constants, [\"[r = 7]\"]), \n(2, [\"1\", \"2\", \"3\"], #Find, Maximum, [\"A\"]), \n(3, [\"1\", \"2\", \"3\"], #Find, AdditionalValues, [\"[u]\", \"[v]\"]), \n(4, [\"1\", \"2\", \"3\"], #Relate, Extremum, [\"A = 2 * u * v - u \<up> 2\"]), \n(5, [\"1\", \"2\"], #Relate, SideConditions, [\"[(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]\"])]"
(*+*)  = vors |> O_Model.to_string @{context}

val SOME ori =
        (*case*) find_first ((fn (_, _, _, _, feedback) => fn (_, _, _, d, ts) =>
           d = I_Model.descriptor feedback andalso subset op = (I_Model.o_model_values feedback, ts))
         (hd icl)) vors (*of*);

(*+*)val "(1, [\"1\", \"2\", \"3\"], #Given, Constants, [\"[r = 7]\"])" =
(*+*)  ori |> O_Model.single_to_string @{context}
\<close> ML \<open> (*\\\\\-------- step into for_problem -----------------------------------------------//*)
(*\\\\\--------------- step into for_problem -----------------------------------------------//*)
\<close> ML \<open> (*\\\\--------- step into find_next_step --------------------------------------------//*)
(*\\\\---------------- step into find_next_step --------------------------------------------//*)
\<close> ML \<open> (*|||---------- continuing specify_do_next --------------------------------------------*)
(*|||----------------- continuing specify_do_next --------------------------------------------*)
\<close> ML \<open> (*while make Test_Theory work*)
val (_, (p_', tac)) = return_find_next_step (*kept for continuing specify_do_next*)

    val ist_ctxt =  Ctree.get_loc pt (p, p_)

(*+*)val Add_Given "Constants [r = 7]" = tac
val _ =
    (*case*) tac (*of*);

\<close> ML \<open>
Step_Specify.by_tactic_input tac (pt, (p, p_'));
\<close> ML \<open>
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Add_Given ct), ptp) =
  (tac, (pt, (p, p_')));

   Specify.by_Add_ "#Given" ct ptp;
"~~~~~ fun by_Add_ , args:"; val (m_field, ct ,(pt, pos as (_, p_))) =
  ("#Given", ct, ptp);
    val (met, oris, (_, pI', mI'), pbl, (_, pI, mI), ctxt) = SpecificationC.get_data (pt, pos)
    val (i_model, m_patt) =
       if p_ = Pos.Met then
         (met,
           (if mI = MethodC.id_empty then mI' else mI) |> MethodC.from_store ctxt |> #model)
       else
         (pbl,
           (if pI = Problem.id_empty then pI' else pI) |> Problem.from_store ctxt |> #model);

      (*case*)
   I_Model.check_single ctxt m_field oris i_model m_patt ct (*of*);
"~~~~~ fun check_single , args:"; val (ctxt, m_field, o_model, i_model, m_patt, (str(*, pos*))) =
  (ctxt, m_field, oris, i_model, m_patt, ct);
        val (t as (descriptor $ _)) = Syntax.read_term ctxt str

(*+*)val "Constants [r = 7]" = UnparseC.term @{context} t;

        val SOME m_field' =
          (*case*) Model_Pattern.get_field descriptor m_patt (*of*);
           (*if*) m_field <> m_field' (*else*);

(*+*)val "#Given" = m_field; val "#Given" = m_field'

val ("", ori', all) =
          (*case*) O_Model.contains ctxt m_field o_model t (*of*);

\<close> ML \<open>
(*+*)val (_, _, _, _, vals) = hd o_model;
\<close> ML \<open>
(*+*)val "Constants [r = 7]" = UnparseC.term @{context} (@{term Constants} $ (hd vals));
(*+*)if "[\n(1, [\"1\", \"2\", \"3\"], #Given, Constants, [\"[r = 7]\"]), " ^ 
(*+*)    "\n(2, [\"1\", \"2\", \"3\"], #Find, Maximum, [\"A\"]), " ^ 
(*+*)    "\n(3, [\"1\", \"2\", \"3\"], #Find, AdditionalValues, [\"[u]\", \"[v]\"]), " ^ 
(*+*)    "\n(4, [\"1\", \"2\", \"3\"], #Relate, Extremum, [\"A = 2 * u * v - u \<up> 2\"]), " ^ 
(*+*)    "\n(5, [\"1\", \"2\"], #Relate, SideConditions, [\"[(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]\"]), " ^ 
(*+*)    "\n(6, [\"3\"], #Relate, SideConditions, [\"[u / 2 = r * sin \<alpha>]\", \"[2 / v = r * cos \<alpha>]\"]), " ^ 
(*+*)    "\n(7, [\"1\"], #undef, FunctionVariable, [\"a\"]), " ^ 
(*+*)    "\n(8, [\"2\"], #undef, FunctionVariable, [\"b\"]), \n(9, [\"3\"], #undef, FunctionVariable, [\"\<alpha>\"]), " ^ 
(*+*)    "\n(10, [\"1\", \"2\"], #undef, Input_Descript.Domain, [\"{0<..<r}\"]), " ^ 
(*+*)    "\n(11, [\"3\"], #undef, Input_Descript.Domain, [\"{0<..<\<pi> / 2}\"]), " ^ 
(*+*)    "\n(12, [\"1\", \"2\", \"3\"], #undef, ErrorBound, [\"\<epsilon> = 0\"])]"
(*+*)= O_Model.to_string @{context} o_model then () else error "o_model CHANGED";
\<close> ML \<open>

  (*case*) is_notyet_input ctxt i_model all ori' m_patt (*of*);
"~~~~~ fun is_notyet_input , args:"; val (ctxt, itms, all, (i, v, f, d, ts), pbt) =
  (ctxt, i_model, all, ori', m_patt);
val SOME (_, (_, pid)) =
  (*case*) find_first (eq1 d) pbt (*of*);
(*local*)fun eq3 f d (_, _, _, f', itm_) = f = f' andalso d = (I_Model.descriptor itm_);(*local*)
\<close> ML \<open>
val SOME (_, _, _, _, itm_) =
    (*case*) find_first (eq3 f d) itms (*of*);
val ts' = inter op = (o_model_values itm_) ts;
            (*if*) subset op = (ts, ts') (*else*);
val return_is_notyet_input = ("", 
           ori_2itm itm_ pid all (i, v, f, d, subtract op = ts' ts));
\<close> ML \<open>
"~~~~~ fun ori_2itm , args:"; val (itm_, pid, all, (id, vt, fd, d, ts)) =
  (itm_, pid, all, (i, v, f, d, subtract op = ts' ts));
\<close> ML \<open>
    val ts' = union op = (o_model_values itm_) ts;
    val pval = [Input_Descript.join'''' (d, ts')]
    val complete = if eq_set op = (ts', all) then true else false

(*+*)val "Inc Constants [] ,(Constants, [])" = itm_ |> I_Model.feedback_to_string @{context}
\<close> ML \<open> (*\\\---------- step into specify_do_next -------------------------------------------//*)
(*\\\----------------- step into specify_do_next -------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into do_next ---------------------------------------------------//*)
(*\\------------------ step into do_next ---------------------------------------------------//*)
val ("ok", (ts as (_, _, _) :: _, _, (pt, p))) = return_do_next
\<close> ML \<open>

\<close> ML \<open>(*|------------- continue with me_Model_Problem ----------------------------------------*)
(*|------------------- continue with me_Model_Problem ----------------------------------------*)
\<close> ML \<open>

val tacis as (_::_) =
        (*case*) ts (*of*);
          val (tac, _, _) = last_elem tacis

\<close> ML \<open>
val return_Model_Problem = (p, [] : NEW, TESTg_form ctxt (pt, p), tac, Celem.Sundef, pt);
\<close> ML \<open>
\<close> ML \<open> (*//----------- step into TESTg_form ------------------------------------------------\\*)
(*//------------------ step into TESTg_form ------------------------------------------------\\*)
"~~~~~ fun TESTg_form , args:"; val (ctxt, ptp) = (ctxt, (pt, p));

\<close> ML \<open>
    val (form, _, _) =
   ME_Misc.pt_extract ctxt ptp;
\<close> ML \<open>
"~~~~~ fun pt_extract , args:"; val (ctxt, (pt, (p, p_(*Frm,Pbl*)))) = (ctxt, ptp);
\<close> ML \<open>
        val ppobj = Ctree.get_obj I pt p
\<close> ML \<open>
        val f = if Ctree.is_pblobj ppobj then pt_model ppobj p_ else Ctree.get_obj pt_form pt p;
\<close> ML \<open>
          (*if*) Ctree.is_pblobj ppobj (*then*);

\<close> ML \<open>
           pt_model ppobj p_;
\<close> ML \<open>
"~~~~~ fun pt_model , args:"; val ((Ctree.PblObj {probl, spec, origin = (_, spec', hdl), ctxt, ...}), 
  Pbl(*Frm,Pbl*)) = (ppobj, p_);
\<close> ML \<open>
      val (_, pI, _) = Ctree.get_somespec' spec spec';
\<close> ML \<open>
                 (*if*) pI = Problem.id_empty (*else*); 
(*    val where_ = if pI = Problem.id_empty then []*)
(*      else                                       *)
(*        let                                      *)
	          val {where_rls, where_, model, ...} = Problem.from_store ctxt pI
\<close> ML \<open>
	          val (_, where_) = (*Pre_Conds.*)check_OLD ctxt where_rls where_ (model, I_Model.OLD_to_TEST probl)
(*        in where_ end                           *)
\<close> ML \<open>  (*ERROR from previous*)
	    val allcorrect = I_Model.is_complete probl andalso foldl and_ (true, (map #1 where_))
\<close> ML \<open>
val return_pt_model = Ctree.ModSpec (allcorrect, Pos.Pbl, hdl, probl, where_, spec)
\<close> ML \<open>
\<close> ML \<open>(*|------------- continue with TESTg_form ----------------------------------------------*)
(*|------------------- continue with TESTg_form ----------------------------------------------*)
\<close> ML \<open> (*while make Test_Theory work*)
val Ctree.ModSpec (spec as (_, p_, _, gfr, where_, _)) =
    (*case*) form (*of*);
    Test_Out.PpcKF (  (Test_Out.Problem [],
 			P_Model.from (Proof_Context.theory_of ctxt) gfr where_));

   P_Model.from (Proof_Context.theory_of ctxt) gfr where_;
"~~~~~ fun from , args:"; val (thy, itms, where_) = ((Proof_Context.theory_of ctxt), gfr, where_);
    fun coll model [] = model
      | coll model ((_, _, _, field, itm_) :: itms) =
        coll (add_sel_ppc thy field model (item_from_feedback thy itm_)) itms;

 val gfr = coll P_Model.empty itms;
"~~~~~ fun coll , args:"; val (model, ((aaa, bbb_,ccc_, field, itm_) :: itms))
  = (P_Model.empty, itms);

(*+*)val 4 = length itms;
(*+*)val itm = nth 1 itms;

           coll P_Model.empty [itm];
"~~~~~ fun coll , iterate:"; val (model, ((aaa, bbb_,ccc_, field, itm_) :: []))
  = (P_Model.empty, [itm]);

          (add_sel_ppc thy field model (item_from_feedback thy itm_));
"~~~~~ fun add_sel_ppc , args:"; val ((_: theory), sel, {Given = gi, Where = wh, Find = fi, With = wi, Relate = re}, x )
  = (thy, field, model, (item_from_feedback thy itm_));

   P_Model.item_from_feedback thy itm_;
"~~~~~ fun item_from_feedback , args:"; val (thy, (I_Model.Inc ((d, ts), _))) = (thy, itm_);
   P_Model.Incompl (UnparseC.term_in_thy thy (Input_Descript.join (d, ts)));
(*\\------------------ step into TESTg_form ------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into TESTg_form ------------------------------------------------//*)
\<close> ML \<open> (*\------------ step into me Model_Problem ------------------------------------------//*)
(*\------------------- step into me Model_Problem ------------------------------------------//*)
\<close> ML \<open> (*while make Test_Theory work*)
val (p, _, f, nxt, _, pt) = return_me_Model_Problem

\<close> ML \<open> (*------------- contine me's ----------------------------------------------------------*)
(*-------------------- contine me's ----------------------------------------------------------*)
val return_me_add_find_Constants = me nxt p c pt;
                                      val Add_Find "Maximum A" = #4 return_me_add_find_Constants;
\<close> ML \<open> (*/------------ step into me_add_find_Constants -------------------------------------\\*)
(*/------------------- step into me_add_find_Constants -------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac as Add_Given "Constants [r = 7]", p, _(*NEW remove*), pt) =
  (nxt, p, c, pt);
\<close> ML \<open>
      val ctxt = Ctree.get_ctxt pt p
\<close> ML \<open>
(*+*)val PblObj {probl = (1, [1, 2, 3], false, "#Given", Inc 
    ((Const ("Input_Descript.Constants", _), []), _)) :: _, ...}  = get_obj I pt (fst p)
(*-------------------------------------------^^--*)
val return_step_by_tactic = (*case*) 
      Step.by_tactic tac (pt, p) (*of*);
\<close> ML \<open> (*//----------- step into Step.by_tactic --------------------------------------------\\*)
(*//------------------ step into Step.by_tactic --------------------------------------------\\*)
"~~~~~ fun by_tactic , args:"; val (tac, (ptp as (pt, p))) = (tac, (pt, p));
\<close> ML \<open>
val Applicable.Yes tac' =
    (*case*) check tac (pt, p) (*of*);
\<close> ML \<open>
	    (*if*) Tactic.for_specify' tac' (*then*);
\<close> ML \<open>
Step_Specify.by_tactic tac' ptp;
\<close> ML \<open>
"~~~~~ fun by_tactic , args:"; val ((Tactic.Add_Given' (ct, _)), (pt, p)) = (tac', ptp);
\<close> ML \<open>
   Specify.by_Add_ "#Given" ct (pt, p);
\<close> ML \<open>
"~~~~~ fun by_Add_ , args:"; val (m_field, ct, (pt, pos as (_, p_))) = ("#Given", ct, (pt, p));
\<close> ML \<open>
    val (met, oris, (_, pI', mI'), pbl, (_, pI, mI), ctxt) = SpecificationC.get_data (pt, pos);
\<close> ML \<open>
(*  val (i_model, m_patt) =*)
       (*if*) p_ = Pos.Met (*else*);
\<close> ML \<open>
val return_by_Add_ =
         (pbl,
           (if pI = Problem.id_empty then pI' else pI) |> Problem.from_store ctxt |> #model)
\<close> ML \<open>
val I_Model.Add i_single =
      (*case*) I_Model.check_single ctxt m_field oris i_model m_patt ct (*of*);
\<close> ML \<open>
\<close> ML \<open>
	          val i_model' =
   I_Model.add_single (Proof_Context.theory_of ctxt) i_single i_model;
\<close> ML \<open>
"~~~~~ fun add_single , args:"; val (thy, itm, model) =
  ((Proof_Context.theory_of ctxt), i_single, i_model);
\<close> ML \<open>
    fun eq_untouched d (0, _, _, _, itm_) = (d = I_Model.descriptor itm_)
      | eq_untouched _ _ = false
\<close> ML \<open>
    val model' = case I_Model.seek_ppc (#1 itm) model of
      SOME _ => overwrite_ppc thy itm model (*itm updated in is_notyet_input WN.11.03*)
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open> (*||----------- contine Step.by_tactic ------------------------------------------------*)
(*||------------------ contine Step.by_tactic ------------------------------------------------*)
(*\\------------------ step into Step.by_tactic --------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into Step.by_tactic --------------------------------------------//*)
val ("ok", (_, _, ptp)) = return_step_by_tactic;
\<close> ML \<open>
      val (pt, p) = ptp;
\<close> ML \<open>
        (*case*) 
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
\<close> ML \<open>
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p, ((pt, Pos.e_pos'), []));
\<close> ML \<open>
  (*if*) Pos.on_calc_end ip (*else*);
\<close> ML \<open>
      val (_, probl_id, _) = Calc.references (pt, p);
\<close> ML \<open>
val _ =
      (*case*) tacis (*of*);
\<close> ML \<open>
        (*if*) probl_id = Problem.id_empty (*else*);
\<close> ML \<open>
           switch_specify_solve p_ (pt, ip);
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
\<close> ML \<open>
      (*if*) Pos.on_specification ([], state_pos) (*then*);
\<close> ML \<open>
           specify_do_next (pt, input_pos);
\<close> ML \<open>
"~~~~~ fun specify_do_next , args:"; val (ptp as (pt, (p, p_))) = (pt, input_pos);
\<close> ML \<open>
    val (_, (p_', tac)) =
   Specify.find_next_step ptp;
\<close> ML \<open>
"~~~~~ fun find_next_step , args:"; val (pt, pos as (_, p_)) = (ptp);
\<close> ML \<open>
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos;
\<close> ML \<open>
(*+*)val (1, [1, 2, 3], true, "#Given", Cor ((Const ("Input_Descript.Constants", _), ts ), _)) :: _
  = pbl
(*+*)val "[[r = 7]]" = UnparseC.terms @{context} ts;
(*-----ML-^------^-HOL*)
\<close> ML \<open>
\<close> ML \<open>
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*); 
\<close> ML \<open>
        (*if*) p_ = Pos.Pbl (*then*); 
\<close> ML \<open>
           for_problem ctxt oris (o_refs, refs) (pbl, met);
\<close> ML \<open>
"~~~~~ fun for_problem , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met)) =
  (ctxt, oris, (o_refs, refs), (pbl, met));
\<close> ML \<open>
\<close> ML \<open>
    val cpI = if pI = Problem.id_empty then pI' else pI;
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = pbt, where_rls, where_, ...} = Problem.from_store ctxt cpI;
    val {model = mpc, ...} = MethodC.from_store ctxt cmI
\<close> ML \<open>
    val (preok, _) =
Pre_Conds.check_OLD ctxt where_rls where_ (pbt, I_Model.OLD_to_TEST pbl);
\<close> ML \<open>
"~~~~~ fun check_OLD , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (pbt, I_Model.OLD_to_TEST pbl));
\<close> ML \<open> (*ERROR lhs called with [r = 7]*)
      val (_, (** )_( **)env_model(**), (env_subst, env_eval)) = of_max_variant model_patt i_model;
\<close> ML \<open>
(*maxi*)val "[\"\n(fixes, [[r = 7]])\"]" = env_model |> Subst.to_string @{context}
(*maxi*)val "[\"\n(fixes, r)\"]" = env_subst |> Subst.to_string @{context}
\<close> ML \<open>
"~~~~~ fun of_max_variant , args:"; val (model_patt, i_model) = (model_patt, i_model);
\<close> ML \<open>
    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (cnt_corrects) variants_separated
    val sum_variant_s = arrange_args1 sums_corr (1, all_variants)
    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
    val equal_descr_pairs = map (get_equal_descr i_model) model_patt |> flat
    val env_model = make_env_model equal_descr_pairs
    val equal_givens = filter (fn ((m_field, _), _) => m_field = "#Given") equal_descr_pairs
\<close> ML \<open>
    val subst_eval_list =
           make_envs_preconds equal_givens;
\<close> ML \<open>
"~~~~~ fun make_envs_preconds , args:"; val (equal_givens) = (equal_givens);
\<close> ML \<open>
val xxx = (fn ((_, (_, id)), (_, _, _, _, (feedb, _))) =>
           discern_feedback id feedb)
val           ((_, (_, id)), (_, _, _, _, (feedb, _))) = nth 1 equal_givens;
\<close> ML \<open>
"~~~~~ fun discern_feedback , args:"; val (id, (Model_Def.Cor_TEST ((descr, ts), _))) = (id, feedb);
\<close> ML \<open>
           discern_typ id (descr, ts);
\<close> ML \<open>
"~~~~~ fun discern_typ , args:"; val (id, (descr, ts)) = (id, (descr, ts));
\<close> ML \<open> (*|------------ contine me_add_find_Constants -----------------------------------------*)
(*|------------------- contine me_add_find_Constants -----------------------------------------*)
(*\------------------- step into me_add_find_Constants -------------------------------------//*)
\<close> ML \<open> (*\------------ step into me_add_find_Constants -------------------------------------//*)
\<close> ML \<open> (*while make Test_Theory work*)
val (p,_,f,nxt,_,pt) = return_me_add_find_Constants;
\<close> ML \<open> (*while make Test_Theory work*)
(*/########################## before destroying elementwise input of lists ##################\* )
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "AdditionalValues [u]" = nxt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "AdditionalValues [v]" = nxt;
( *\########################## before destroying elementwise input of lists ##################/*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "AdditionalValues [u, v]" = nxt;

val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Relation "Extremum (A = 2 * u * v - u \<up> 2)" = nxt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Relation "SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]" = nxt;

val return_me_Add_Relation_SideConditions
                     = me nxt p c pt;
(*+*)val (_, _, _, Specify_Theory "Diff_App", _, _) = return_me_Add_Relation_SideConditions; (*###############*)
\<close> ML \<open>(*/------------- step into me Add_Relation_SideConditions ----------------------------\\*)
(*/------------------- step into me Add_Relation_SideConditions ----------------------------\\*)
\<close> ML \<open>
"~~~~~ fun me , args:"; val (tac, p, _, pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p;
\<close> ML \<open>
(**)  val (pt, p) = (**) 
  	    (**)case(**) Step.by_tactic tac (pt, p) (**)of(**)
(**) 		    ("ok", (_, _, ptp)) => ptp (**) ;
\<close> ML \<open> (*ERROR "helpless"*)
    (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
\<close> ML \<open> (*//----------- step into do_next ---------------------------------------------------\\*)
(*//------------------ step into do_next ---------------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis))
  = (p, ((pt, Pos.e_pos'), [])) (*of*);
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

\<close> ML \<open> (*ERROR "helpless"*)
      Step.switch_specify_solve p_ (pt, ip);
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);
\<close> ML \<open> (*ERROR "failure"*)
      Step.specify_do_next (pt, input_pos);
\<close> ML \<open>
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = (pt, input_pos);
\<close> ML \<open> (*ERROR "failure"*)
(*isa------ERROR: Refine_Problem INSTEAD 
            isa2: Specify_Theory "Diff_App"*)
    val (_, (p_', tac as Specify_Theory "Diff_App")) =
(*ERROR------------------^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^*)
   Specify.find_next_step ptp;
\<close> ML \<open>
"~~~~~ fun find_next_step , args:"; val (pt, pos as (_, p_)) = (ptp);
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos;
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
\<close> ML \<open>
        (*if*) p_ = Pos.Pbl (*then*);
\<close> ML \<open>  (*ERROR Refine_Problem INSTEAD Specify_Theory "Diff_App"*)
val ("dummy", (Pbl, tac as Specify_Theory "Diff_App")) =
(*ERROR------------------^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^*)
          for_problem ctxt oris (o_refs, refs) (pbl, met);
\<close> ML \<open>
"~~~~~ fun for_problem , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met)) =
  (ctxt, oris, (o_refs, refs), (pbl, met));
    val cpI = if pI = Problem.id_empty then pI' else pI;
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = pbt, where_rls, where_, ...} = Problem.from_store ctxt cpI;
    val {model = mpc, ...} = MethodC.from_store ctxt cmI

(*+*)val [Const ("Orderings.ord_class.less", _) $ Const ("Groups.zero_class.zero", _) $
  Free ("fixes", _)] = where_

\<close> ML \<open> (*ERROR false*)
    val (preok, _) =
 Pre_Conds.check_OLD ctxt where_rls where_ (pbt, I_Model.OLD_to_TEST pbl);
\<close> ML \<open>
\<close> ML \<open> (*///---------- step into check_OLD -------------------------------------------------\\*)
(*///----------------- step into check_OLD -------------------------------------------------\\*)
"~~~~~ fun check_OLD , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (pbt, I_Model.OLD_to_TEST pbl));
\<close> ML \<open>
(*+*)val "[0 < fixes]" = pres |> UnparseC.terms @{context}
(*+*)val "[\"(#Given, (Constants, fixes))\", \"(#Find, (Maximum, maxx))\", \"(#Find, (AdditionalValues, vals))\", \"(#Relate, (Extremum, extr))\", \"(#Relate, (SideConditions, sideconds))\"]"
(*+*)  = model_patt |> Model_Pattern.to_string @{context}
\<close> ML \<open>
(*+*)val "[\n(1, [1, 2, 3], true ,#Given, (Cor_TEST Constants [r = 7] , pen2str, Position.T)), \n(2, [1, 2, 3], true ,#Find, (Cor_TEST Maximum A , pen2str, Position.T)), \n(3, [1, 2, 3], true ,#Find, (Cor_TEST AdditionalValues [u, v] , pen2str, Position.T)), \n(4, [1, 2, 3], true ,#Relate, (Cor_TEST Extremum (A = 2 * u * v - u \<up> 2) , pen2str, Position.T)), \n(5, [1, 2], true ,#Relate, (Cor_TEST SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2] , pen2str, Position.T))]"
 = i_model |> I_Model.to_string_TEST @{context}
\<close> ML \<open>
val return_of_max_variant as (_, _, (env_subst, env_eval)) =
           of_max_variant model_patt i_model
\<close> ML \<open>
(*maxi*)val "[\"\n(fixes, [[r = 7]])\"]" = env_model |> Subst.to_string @{context}
(*maxi*)val "[\"\n(fixes, r)\"]" = env_subst |> Subst.to_string @{context}
(*+*)val [(Free ("fixes", T1), Free ("r", T2))] = env_subst (*?!? Const*)
(*+*)val Type ("Real.real", []) = T1
(*+*)val Type ("Real.real", []) = T2
\<close> ML \<open>
(*+*)val [(Free ("r", T2), Const ("Num.numeral_class.numeral", _) $ _)] = env_eval
(*+*)val Type ("Real.real", []) = T2
\<close> ML \<open>
\<close> ML \<open> (*while make Test_Theory work*)
val (_, _, (env_subst, env_eval)) = return_of_max_variant;
\<close> ML \<open> (*|||---------- contine check_OLD -----------------------------------------------------*)
(*|||----------------- contine check_OLD -----------------------------------------------------*)
\<close> ML \<open>
      val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
\<close> ML \<open>
\<close> ML \<open> (*|||---------- contine check_OLD -----------------------------------------------------*)
(*|||----------------- contine check_OLD -----------------------------------------------------*)
\<close> ML \<open>
(*+*)val [(true, Const ("Orderings.ord_class.less", _) $
  Const ("Groups.zero_class.zero", _) $ Free ("r", _))] = pres_subst

\<close> ML \<open>
      val full_subst = map (fn (bool, t) => (bool, subst_atomic env_eval t)) pres_subst
\<close> ML \<open>
(*+*)val [(true,
     Const ("Orderings.ord_class.less", _) $ Const ("Groups.zero_class.zero", _) $
       (Const ("Num.numeral_class.numeral", _) $ _))] = full_subst

      val evals = map (eval ctxt where_rls) full_subst
val return_check_OLD = (foldl and_ (true, map fst evals), pres_subst)
\<close> ML \<open> (*\\\---------- step into check_OLD -------------------------------------------------\\*)
(*\\\----------------- step into check_OLD -------------------------------------------------\\*)
\<close> ML \<open>
    val (preok as true, _) = return_check_OLD
(*+---------------^^^^*)
\<close> ML \<open> (*\\----------- step into do_next ---------------------------------------------------\\*)
(*\\------------------ step into do_next ---------------------------------------------------\\*)
\<close> ML \<open>(*\------------- step into me_Add_Relation_SideConditions ----------------------------//*)
(*\------------------- step into me_Add_Relation_SideConditions ----------------------------//*)
\<close> ML \<open> (*while make Test_Theory work*)
val (p, _, f, nxt, _, pt) = return_me_Add_Relation_SideConditions
                                      val Specify_Theory "Diff_App" = nxt;

val return_me_Specify_Theory
                     = me nxt p c pt; val Specify_Problem ["univariate_calculus", "Optimisation"] = #4 return_me_Specify_Theory;
(*/------------------- step into me Specify_Theory -----------------------------------------\\*)
\<close> ML \<open> (*/------------ step into me Specify_Theory -----------------------------------------\\*)
\<close> ML \<open>
"~~~~~ fun me , args:"; val (tac, p, _, pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p;
\<close> ML \<open>
(*      val (pt, p) = *)
  	    (*case*) Step.by_tactic tac (pt, p) (*of*);
(*		    ("ok", (_, _, ptp)) => ptp *)
val return_Step_by_tactic =
      Step.by_tactic tac (pt, p);
\<close> ML \<open> (*//----------- step into Step_by_tactic --------------------------------------------\\*)
(*//------------------ step into Step_by_tactic --------------------------------------------\\*)
\<close> ML \<open>
"~~~~~ fun by_tactic , args:"; val (tac, (ptp as (pt, p))) = (tac, (pt, p));
\<close> ML \<open>
    (*case*) check tac (pt, p) (*of*);
\<close> ML \<open> (*||----------- contine Step_by_tactic ------------------------------------------------*)
(*||------------------ contine Step_by_tactic ------------------------------------------------*)
(*\\------------------ step into Step_by_tactic --------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into Step_by_tactic --------------------------------------------//*)
\<close> ML \<open>
val ("ok", (_, _, ptp)) = return_Step_by_tactic;
(*|------------------- continue me Specify_Theory --------------------------------------------*)
\<close> ML \<open> (*|------------ continue me Specify_Theory --------------------------------------------*)
\<close> ML \<open>
val ("ok", (ts as (_, _, _) :: _, _, _)) =
    (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
\<close> ML \<open> (*//----------- step into Step_do_next ----------------------------------------------\\*)
(*//------------------ step into Step_do_next ----------------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis))
  = (p, ((pt, Pos.e_pos'), [])) (*of*);
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = (pt, input_pos);
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_);
    (*case*) tac (*of*);

\<close> ML \<open>
Step_Specify.by_tactic_input tac (pt, (p, p_'));
(*+*)val Specify_Theory "Diff_App" = tac;
\<close> ML \<open>
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Specify_Theory dI), (pt, pos as (_, Pbl)))
  = (tac, (pt, (p, p_')));
      val (oris, dI, dI', pI', probl, ctxt) = case get_obj I pt p of
        PblObj {origin = (oris, (dI,_,_),_), spec = (dI',pI',_), probl, ctxt, ...} =>
          (oris, dI, dI', pI', probl, ctxt)
	    val thy = ThyC.get_theory ctxt (if dI' = ThyC.id_empty then dI else dI');
      val {model, where_, where_rls,...} = Problem.from_store (Ctree.get_ctxt pt pos) pI
(*\\------------------ step into do_next ---------------------------------------------------//*)
(*\------------------- step into me Specify_Theory -----------------------------------------//*)
val (p,_,f,nxt,_,pt) = return_me_Specify_Theory;

val return_me_Specify_Problem (* keep for continuing me *)
                     = me nxt p c pt; val Specify_Method ["Optimisation", "by_univariate_calculus"] = #4 return_me_Specify_Problem;
(*/------------------- step into me Specify_Problem ----------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _, pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p

(** )  val ("ok", (_, _, ptp as (pt, p))) =( **)
(**)    val return_by_tactic =(**) (*case*)
      Step.by_tactic tac (pt, p) (*of*);
(*//------------------ step into by_tactic -------------------------------------------------\\*)
"~~~~~ fun by_tactic , args:"; val (tac, (ptp as (pt, p))) = (tac, (pt, p));

    (*case*)
      Step.check tac (pt, p) (*of*);
"~~~~~ fun check , args:"; val (tac, (ctree, pos)) = (tac, (pt, p));
  (*if*) Tactic.for_specify tac (*then*);

Specify_Step.check tac (ctree, pos);
"~~~~~ fun check , args:"; val ((Tactic.Specify_Problem pID), (pt, pos as (p, _)))
  = (tac, (ctree, pos));
		    val (oris, dI, pI, dI', pI', itms) = case Ctree.get_obj I pt p of
		      Ctree.PblObj {origin = (oris, (dI, pI, _), _), spec = (dI', pI', _), probl = itms, ...}
		        => (oris, dI, pI, dI', pI', itms)
	      val thy = ThyC.get_theory ctxt (if dI' = ThyC.id_empty then dI else dI');
(*\\------------------ step into by_tactic -------------------------------------------------//*)
val ("ok", (_, _, ptp as (pt, p))) = return_by_tactic (* kept for continuing me *);

      (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (p, ((pt, Pos.e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = ((pt, input_pos));
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
val _ =
    (*case*) tac (*of*);

Step_Specify.by_tactic_input tac (pt, (p, p_'));
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Specify_Method id), (pt, pos))
  = (tac, (pt, (p, p_')));

      val (o_model, ctxt, i_model) =
Specify_Step.complete_for id (pt, pos);
"~~~~~ fun complete_for , args:"; val (mID, (ctree, pos)) = (id, (pt, pos));
    val {origin = (o_model, o_refs, _), spec = refs, probl = i_prob, ctxt,
       ...} = Calc.specify_data (ctree, pos);
    val ctxt = Ctree.get_ctxt ctree pos
    val (dI, _, _) = References.select_input o_refs refs;
    val {model = m_patt, where_, where_rls, ...} = MethodC.from_store ctxt mID
    val {origin = (root_model, _, _), ...} = Calc.specify_data (ctree, ([], Pos.Und))
    val (o_model', ctxt') = O_Model.complete_for m_patt root_model (o_model, ctxt)
    val thy = ThyC.get_theory ctxt dI
    val (_, (i_model, _)) = M_Match.match_itms_oris ctxt i_prob (m_patt, where_, where_rls) o_model';
(*\------------------- step into me Specify_Problem ----------------------------------------//*)
val (p,_,f,nxt,_,pt) = return_me_Specify_Problem

val return_me_Add_Given_FunctionVariable
                     = me nxt p c pt; val Add_Given "FunctionVariable a" = #4 return_me_Add_Given_FunctionVariable;
(*/------------------- step into me Specify_Method -----------------------------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _, pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p
      val (pt, p) = 
  	    (*Step.by_tactic is here for testing by me; do_next would suffice in me*)
  	    case Step.by_tactic tac (pt, p) of
  		    ("ok", (_, _, ptp)) => ptp;

         (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (p, ((pt, Pos.e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = (pt, input_pos);

    val (_, (p_', tac)) =
   Specify.find_next_step ptp;
"~~~~~ fun find_next_step , args:"; val ((pt, pos as (_, p_))) = (ptp);
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos;
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
        (*if*) p_ = Pos.Pbl (*else*);

\<close> ML \<open>
   Specify.for_method ctxt oris (o_refs, refs) (pbl, met);
\<close> ML \<open>
"~~~~~ fun for_method , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (_, met))
  = (ctxt, oris, (o_refs, refs), (pbl, met));
\<close> ML \<open>
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = mpc, where_rls, where_, ...} = MethodC.from_store ctxt cmI;    (*..MethodC ?*)
    val (preok, _) = Pre_Conds.check_OLD ctxt where_rls where_ (mpc, I_Model.OLD_to_TEST met);
val NONE =
    (*case*) find_first (I_Model.is_error o #5) met (*of*);

\<close> ML \<open>
      (*case*)
   Specify.item_to_add (ThyC.get_theory ctxt 
     (if dI = ThyC.id_empty then dI' else dI)) oris mpc met (*of*);
\<close> ML \<open>
"~~~~~ fun item_to_add , args:"; val (thy, oris, _, itms)
  = ((ThyC.get_theory ctxt (if dI = ThyC.id_empty then dI' else dI)), oris, mpc, met);
\<close> ML \<open>
(*\------------------- step into me Specify_Method -----------------------------------------//*)
val (p,_,f,nxt,_,pt) = return_me_Add_Given_FunctionVariable

val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Input_Descript.Domain {0<..<r}" = nxt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "ErrorBound (\<epsilon> = 0)" = nxt;
\<close> ML \<open> (*/------------ step into me_Add_Given_ErrorBound------------------------------------\\*)
(* ------------------- step into UNTIL A PROGRAM IS REQUIRED (not yet impl. ---------------- )*)
(*/------------------- step into me_Add_Given_ErrorBound------------------------------------\\*)
\<close> ML \<open>
"~~~~~ fun me , args:"; val (tac, p, _(*NEW remove*), pt) = (nxt, p, c, pt);
\<close> ML \<open>
      val ctxt = Ctree.get_ctxt pt p
      val (pt, p) = 
  	    (*Step.by_tactic is here for testing by me; do_next would suffice in me*)
  	    case Step.by_tactic tac (pt, p) of
  		    ("ok", (_, _, ptp)) => ptp;
\<close> ML \<open>
(*ERROR due to missing program in creating the environment from formal args* )
      (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
( *ERROR*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis) ) =
  (p, ((pt, Pos.e_pos'), []));
\<close> ML \<open>
  (*if*) Pos.on_calc_end ip (*else*); 
\<close> ML \<open>
      val (_, probl_id, _) = Calc.references (pt, p);
\<close> ML \<open>
val _ =
      (*case*) tacis (*of*);
\<close> ML \<open>
        (*if*) probl_id = Problem.id_empty (*else*);
\<close> ML \<open>
(*ERROR due to missing program in creating the environment from formal args* )
           switch_specify_solve p_ (pt, ip);
( *ERROR*)
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
\<close> ML \<open>
      (*if*) Pos.on_specification ([], state_pos) (*then*);
\<close> ML \<open>
(*ERROR due to missing program in creating the environment from formal args* )
           specify_do_next (pt, input_pos)
( *ERROR*)
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = ((pt, input_pos));
\<close> ML \<open>
    val (_, (p_', tac as Apply_Method ["Optimisation", "by_univariate_calculus"])) =
    (*-------------------^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ not yet impl.*)
      Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
\<close> ML \<open>
val Tactic.Apply_Method (mI as ["Optimisation", "by_univariate_calculus"]) =
        (*case*) tac (*of*);
\<close> ML \<open>
(*ERROR due to missing program in creating the environment from formal args* )
  	    LI.by_tactic (Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty))
  	      ist_ctxt (pt, (p, p_'))
( *ERROR*)
"~~~~~ fun by_tactic , args:"; val ((Tactic.Apply_Method' (mI, _, _, _)), (_, ctxt), (pt, pos as (p, _))) =
  ((Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty)), ist_ctxt, (pt, (p, p_')));
\<close> ML \<open>
      val (itms, oris, probl) = case get_obj I pt p of
          PblObj {meth = itms, origin = (oris, _, _), probl, ...} => (itms, oris, probl)
      val {model, ...} = MethodC.from_store ctxt mI;
\<close> ML \<open>
      (*if*) itms <> [] (*then*);
\<close> ML \<open>
      val itms = I_Model.complete oris probl [] model
\<close> ML \<open>
(*+*)val "[\n(1 ,[1, 2, 3] ,true ,#Given ,Cor Constants [r = 7] ,(fixes, [[r = 7]])), \n(2 ,[1, 2, 3] ,true ,#Find ,Cor Maximum A ,(maxx, [A])), \n(3 ,[1, 2, 3] ,true ,#Find ,Cor AdditionalValues [u, v] ,(vals, [[u, v]])), \n(4 ,[1, 2, 3] ,true ,#Relate ,Cor Extremum (A = 2 * u * v - u \<up> 2) ,(extr, [A = 2 * u * v - u \<up> 2])), \n(5 ,[1, 2] ,true ,#Relate ,Cor SideConditions [(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2] ,(sideconds, [[(u / 2) \<up> 2 + (2 / v) \<up> 2 = r \<up> 2]])), \n(7 ,[1] ,true ,#Given ,Cor FunctionVariable a ,(funvar, [a])), \n(10 ,[1, 2] ,true ,#Given ,Cor Input_Descript.Domain {0<..<r} ,(doma, [{0<..<r}])), \n(12 ,[1, 2, 3] ,true ,#Given ,Cor ErrorBound (\<epsilon> = 0) ,(err, [\<epsilon> = 0]))]"
 = itms |> I_Model.to_string @{context}
(*+*)val 8 = length itms
(*+*)val 8 = length model
(*\------------------- step into me_Add_Given_ErrorBound------------------------------------//*)
\<close> ML \<open> (*\------------ step into me_Add_Given_ErrorBound------------------------------------//*)
\<close> ML \<open>
\<close> ML \<open>
\<close>

section \<open>=====equa "Minisubpbl/100-init-rootpbl-NEXT_STEP.sml" =================================\<close>
ML \<open>
\<close> ML \<open>
(* Title:  "Minisubpbl/100-init-rootpbl-NEXT_STEP.sml"
   Author: Walther Neuper 2307
*)
(*overwrites NEW funs in Test_Theory ABOVE* )
open Ctree;
open Pos;
open TermC;
open Istate;
open Tactic;
open I_Model;
open Pre_Conds;
open Rewrite;
open Step;
open Specify;
open LItool;
open LI;
( *overwrites NEW funs in Test_Theory ABOVE*)

"----------- Minisubpbl/100-init-rootpbl-NEXT_STEP.sml ---------------------------------------";
"----------- Minisubpbl/100-init-rootpbl-NEXT_STEP.sml ---------------------------------------";
"----------- Minisubpbl/100-init-rootpbl-NEXT_STEP.sml ---------------------------------------";
tracing "--- Minisubplb/100-init-rootpbl-NEXT_STEP.sml ---------------------------------------";
val fmz = ["equality (x+1=(2::real))", "solveFor x", "solutions L"];
val (dI',pI',mI') =
  ("Test", ["sqroot-test", "univariate", "equation", "test"],
   ["Test", "squ-equ-test-subpbl1"]);
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Model_Problem = tac
\<close> ML \<open>
val return_do_next_Model_Problem as xxx = 
      Step.do_next p ((pt, e_pos'), []);
\<close> ML \<open>
val return_do_next_Model_Problem as ("ok", ([(Specify_Theory "Test", _, _)], _, _))
  = Step.do_next p ((pt, e_pos'), []);
\<close> ML \<open> (*/------------ step into do_next_Model_Problem -------------------------------------\\*)
(*/------------------- step into do_next_Model_Problem -------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (p, ((pt, e_pos'), []));
\<close> ML \<open>
  (*if*) Pos.on_calc_end ip (*else*);
\<close> ML \<open>
      val (_, probl_id, _) = Calc.references (pt, p);
\<close> ML \<open>
val _ =
      (*case*) tacis (*of*);
\<close> ML \<open>
        (*if*) probl_id = Problem.id_empty (*else*);
\<close> ML \<open>
           switch_specify_solve p_ (pt, ip);
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
\<close> ML \<open>
      (*if*) Pos.on_specification ([], state_pos) (*then*);
\<close> ML \<open>
           specify_do_next (pt, input_pos);
\<close> ML \<open>
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = ((pt, input_pos));
\<close> ML \<open>
    val (_, (p_', tac as Specify_Theory "Test")) =
   Specify.find_next_step ptp;
\<close> ML \<open>
"~~~~~ fun find_next_step , args:"; val ((pt, pos as (_, p_))) = (ptp);
\<close> ML \<open>
    val {meth = met, origin = origin as (oris, o_refs as (_, pI', mI'), _), probl = pbl,
      spec = refs, ...} = Calc.specify_data (pt, pos);
    val ctxt = Ctree.get_ctxt pt pos
\<close> ML \<open>
      (*if*) Ctree.just_created (pt, pos) andalso origin <> Ctree.e_origin (*else*);
\<close> ML \<open>
        (*if*) p_ = Pos.Pbl (*then*);
\<close> ML \<open>
           for_problem ctxt oris (o_refs, refs) (pbl, met);
\<close> ML \<open>
"~~~~~ fun for_problem , args:"; val (ctxt, oris, ((dI', pI', mI'), (dI, pI, mI)), (pbl, met)) =
  (ctxt, oris, (o_refs, refs), (pbl, met));
\<close> ML \<open>
    val cpI = if pI = Problem.id_empty then pI' else pI;
    val cmI = if mI = MethodC.id_empty then mI' else mI;
    val {model = pbt, where_rls, where_, ...} = Problem.from_store ctxt cpI;
    val {model = mpc, ...} = MethodC.from_store ctxt cmI
\<close> ML \<open> (*ERROR?---vvvvv*)
    val (preok as true, xxx) =
 Pre_Conds.check_OLD ctxt where_rls where_ (pbt, I_Model.OLD_to_TEST pbl);
\<close> ML \<open>
(*+*)val "[\n(1, [1], true ,#Given, (Cor_TEST equality (x + 1 = 2) , pen2str, Position.T)), \n(2, [1], true ,#Given, (Cor_TEST solveFor x , pen2str, Position.T)), \n(3, [1], true ,#Find, (Cor_TEST solutions L , pen2str, Position.T))]"
 = I_Model.OLD_to_TEST pbl |> I_Model.to_string_TEST @{context};
(*+*)val "[precond_rootpbl v_v]" = where_ |> UnparseC.terms @{context};
\<close> ML \<open>
"~~~~~ fun check_OLD , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (pbt, I_Model.OLD_to_TEST pbl));
\<close> ML \<open>
      val (_, env_model, (env_subst, env_eval)) = of_max_variant model_patt i_model
\<close> ML \<open>
(*equa*)val "[\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\", \"\n(v_v'i', L)\"]" = env_model |> Subst.to_string @{context}
(*equa*)val "[]" = env_subst |> Subst.to_string @{context}
\<close> ML \<open>
      val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
\<close> ML \<open>
(*+*)val [(false, Const ("Test.precond_rootpbl", _) $ Free ("v_v", _))] = pres_subst
\<close> ML \<open>
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
\<close> ML \<open>
(*+*)val "[\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\", \"\n(v_v'i', L)\"]"
  = env_model |> Subst.to_string @{context}
(*+*)val [(true, Const ("Test.precond_rootpbl", _) $ Free ("x", _))] = pres_subst_other
\<close> ML \<open>
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)
\<close> ML \<open>
(*+*)val [] = env_eval
(*+*)val [(true, Const ("Test.precond_rootpbl", _) $ Free ("x", _))] = full_subst
\<close> ML \<open>
      val evals = map (eval ctxt where_rls) full_subst
\<close> ML \<open>
(*+*)val [(true, Const ("Test.precond_rootpbl", _) $ Free ("x", _))] = evals
\<close> ML \<open>
val return_check_OLD = (foldl and_ (true, map fst evals), pres_subst_other)
\<close> ML \<open>
(*+*)val (true, [(true, Const ("Test.precond_rootpbl", _) $ Free ("x", _))]) = return_check_OLD
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open> (*|------------ contine do_next_Model_Problem -----------------------------------------*)
(*|------------------- contine do_next_Model_Problem -----------------------------------------*)
(*\------------------- step into do_next_Model_Problem -------------------------------------//*)
\<close> ML \<open> (*\------------ step into do_next_Model_Problem -------------------------------------//*)
val (_, ([(tac as Specify_Theory "Test", _, _)], _, (pt, p))) = return_do_next_Model_Problem;
\<close> ML \<open>
(*[], Pbl*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Specify_Problem ["sqroot-test", "univariate", "equation", "test"] = tac

(*[], Met*)val return_Step_do_next_Specify_Problem = Step.do_next p ((pt, e_pos'), []);(*Specify_Method ["Test", "squ-equ-test-subpbl1"]*)
(*/------------------- step into Step.do_next_Specify_Problem ------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p, ((pt, e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

\<close> ML \<open>
      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

      Step.specify_do_next (pt, input_pos);
"~~~~~ fun specify_do_next , args:"; val ((ptp as (pt, (p, p_)))) = ((pt, input_pos));
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
val _ =
    (*case*) tac (*of*);

Step_Specify.by_tactic_input tac (pt, (p, p_'));
"~~~~~ fun by_tactic_input , args:"; val ((Tactic.Specify_Method id), (pt, pos)) =
  (tac, (pt, (p, p_')));

\<close> ML \<open>
      val (o_model, ctxt, i_model) =
Specify_Step.complete_for id (pt, pos);
"~~~~~ fun complete_for , args:"; val (mID, (ctree, pos)) = (id, (pt, pos));
    val {origin = (o_model, _, _), probl = i_prob, ctxt,
       ...} = Calc.specify_data (ctree, pos);
    val {model = m_patt, where_, where_rls, ...} = MethodC.from_store ctxt mID
    val {origin = (root_model, _, _), ...} = Calc.specify_data (ctree, ([], Pos.Und))
    val (o_model', ctxt') = O_Model.complete_for m_patt root_model (o_model, ctxt)

    val (_, (i_model, _)) =
   M_Match.match_itms_oris ctxt i_prob (m_patt, where_, where_rls) o_model';
"~~~~~ fun match_itms_oris , args:"; val (ctxt, pbl, (pbt, where_, where_rls), oris) =
  (ctxt, i_prob, (m_patt, where_, where_rls), o_model');
 (*0*)val mv = Pre_Conds.max_variant pbl;

      fun eqdsc_pbt_itm ((_,(d,_))) (_, _, _, _, itm_) = d = I_Model.descriptor itm_;
      fun notmem pbl pbt1 = case find_first (eqdsc_pbt_itm pbt1) pbl of
				SOME _ => false | NONE => true;
 (*1*)val mis = (filter (notmem pbl)) pbt;
      fun eqdsc_ori (_,(d,_)) (_, _, _, d', _) = d = d';
      fun ori2itmMis (f, (d, pid)) (i, v, _, _, _) = (i, v, false, f, I_Model.Mis (d, pid));
 (*2*)fun oris2itms oris mis1 = ((map (ori2itmMis mis1)) o (filter (eqdsc_ori mis1))) oris;
      val news = (flat o (map (oris2itms oris))) mis;
 (*3*)fun mem_vat (_, vats, _, _, _) = member op = vats mv;
      val newitms = filter mem_vat news;
 (*4*)val itms' = pbl @ newitms;

\<close> ML \<open>
      val (pb, where_') =
 Pre_Conds.check_OLD ctxt where_rls where_ (m_patt, I_Model.OLD_to_TEST itms');
\<close> ML \<open>
"~~~~~ fun check_OLD , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (m_patt, I_Model.OLD_to_TEST itms'));
      val (_, env_model, (env_subst, env_eval)) = of_max_variant model_patt i_model
\<close> ML \<open>
(*equa*)val "[\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\", \"\n(v_v'i', L)\"]" = env_model |> Subst.to_string @{context}
(*equa*)val "[]" = env_subst |> Subst.to_string @{context}
\<close> ML \<open>
      val pres_subst = map (TermC.subst_atomic_all env_subst) pres;
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)

\<close> ML \<open>
(*+*)val "Test" = ctxt |> Proof_Context.theory_of  |> ThyC.id_of
(*+*)val Rule_Set.Repeat {id = "prls_met_test_squ_sub", ...} = where_rls
(*+*)val [(true, tTEST as Const ("Test.precond_rootmet", _) $ Free ("x", xxx))] = pres_subst_other

\<close> ML \<open>
\<close> ML \<open>
(*+*)val ctxt = Config.put rewrite_trace true ctxt;
      val evals = map (
 Pre_Conds.eval ctxt where_rls) full_subst;
(*
@## rls: prls_met_test_squ_sub on: precond_rootmet x 
@### try calc: "Test.precond_rootmet" 
@#### eval asms: "(precond_rootmet x) = True" 
@### calc. to: True 
@### try calc: "Test.precond_rootmet" 
@### try calc: "Test.precond_rootmet" 
*)
(*+*)val ctxt = Config.put rewrite_trace false ctxt;

\<close> ML \<open>
"~~~~~ fun eval_precond_rootmet , args:"; val ((thmid:string), _, (t as (Const (\<^const_name>\<open>Test.precond_rootmet\<close>, _) $ arg)), ctxt) =
  ("aaa", "bbb", tTEST, ctxt);
    SOME (TermC.mk_thmid thmid (UnparseC.term ctxt arg) "",
      HOLogic.Trueprop $ (TermC.mk_equality (t, @{term True})))
;
    (TermC.mk_thmid thmid (UnparseC.term ctxt arg)) "";
\<close> ML \<open>
"~~~~~ fun mk_thmid , args:"; val (thmid, n1, n2) = (thmid, (UnparseC.term ctxt arg), "");
  thmid ^ (cut_longid n1) ^ "_" ^ (cut_longid n2);

\<close> ML \<open>
      (cut_longid n2);
"~~~~~ fun cut_longid , args:"; val (dn) = (n2);
(*\------------------- step into Step.do_next_Specify_Problem ------------------------------//*)
val (_, ([(tac, _, _)], _, (pt, p))) = return_Step_do_next_Specify_Problem; val Specify_Method ["Test", "squ-equ-test-subpbl1"] = tac;

\<close> ML \<open>
(*[1], Frm*)val return_Step_do_next_Specify_Method = Step.do_next p ((pt, e_pos'), []);(*Apply_Method ["Test", "squ-equ-test-subpbl1"]*)
\<close> ML \<open>(*/------------- step into do_next_Specify_Method ------------------------------------\\*)
(*/------------------- step into do_next_Specify_Method ------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p, ((pt, e_pos'), []));
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

\<close> ML \<open> (*ERROR 2 formal args: [e_e, v_v], 0 actual args: []*)
           switch_specify_solve p_ (pt, ip);
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*then*);

\<close> ML \<open> (*ERROR 2 formal args: [e_e, v_v], 0 actual args: []*)
           specify_do_next (pt, input_pos);
\<close> ML \<open>
"~~~~~ fun specify_do_next , args:"; val (ptp as (pt, (p, p_))) = (pt, input_pos);
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
(*+*)val Tactic.Apply_Method mI =
    (*case*) tac (*of*);

\<close> ML \<open> (*ERROR 2 formal args: [e_e, v_v], 0 actual args: []*)
  	    LI.by_tactic (Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty))
  	      ist_ctxt (pt, (p, p_'));
\<close> ML \<open>
"~~~~~ fun by_tactic , args:"; val ((Tactic.Apply_Method' (mI, _, _, _)), (_, ctxt), (pt, pos as (p, _))) =
  ((Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty)),
  	      ist_ctxt, (pt, (p, p_')));
         val (itms, oris, probl) = case get_obj I pt p of (*STILL asms=[]*)
           PblObj {meth = itms, origin = (oris, _, _), probl, ...} => (itms, oris, probl)
         | _ => raise ERROR "LI.by_tactic Apply_Method': uncovered case get_obj"
         val {model, ...} = MethodC.from_store ctxt mI;
         val itms = if itms <> [] then itms else I_Model.complete oris probl [] model

\<close> ML \<open>
         val return_init_pstate = case
           LItool.init_pstate ctxt (I_Model.OLD_to_TEST itms) mI of
             (is as Pstate {env, ...}, ctxt, program) => (is, env, ctxt, program)
(*#------------------- un-hide local of init_pstate -----------------------------------------\*)
fun msg_miss ctxt sc metID caller f formals actuals =
  "ERROR in creating the environment from formal args. of partial_function \"" ^ fst (Program.get_fun_id sc) ^ "\"\n" ^
	"and the actual args., ie. items of the guard of \"" ^ MethodC.id_to_string metID ^ "\" by \"" ^ caller ^ "\":\n" ^
	"formal arg \"" ^ UnparseC.term ctxt f ^ "\" doesn't match any actual arg.\n" ^
	"with:\n" ^
	(string_of_int o length) formals ^ " formal args: " ^ UnparseC.terms ctxt formals ^ "\n" ^
	(string_of_int o length) actuals ^ " actual args: " ^ UnparseC.terms ctxt actuals
fun msg_miss_type ctxt sc metID f formals actuals =
  "ERROR in creating the environment from formal args. of partial_function \"" ^ fst (Program.get_fun_id sc) ^ "\"\n" ^
	"and the actual args., ie. items of the guard of \"" ^ MethodC.id_to_string metID ^ "\" by \"assoc_by_type\":\n" ^
	"formal arg \"" ^ UnparseC.term ctxt f ^ "\" of type \"" ^ UnparseC.typ ctxt (type_of f) ^
  "\" doesn't mach any actual arg.\nwith:\n" ^
	(string_of_int o length) formals ^ " formal args: " ^ UnparseC.terms ctxt formals ^ "\n" ^
	(string_of_int o length) actuals ^ " actual args: " ^ UnparseC.terms ctxt actuals ^ "\n" ^
  "   with types: " ^ (strs2str o (map ((UnparseC.typ ctxt) o type_of))) actuals
fun msg_ambiguous ctxt sc metID f aas formals actuals =
  "AMBIGUITY in creating the environment from formal args. of partial_function \"" ^ fst (Program.get_fun_id sc) ^ "\"\n" ^
	"and the actual args., ie. items of the guard of \"" ^ MethodC.id_to_string metID ^ "\" by \"assoc_by_type\":\n" ^
  "formal arg. \"" ^ UnparseC.term ctxt f ^ "\" type-matches with several..."  ^
  "actual args. \"" ^ UnparseC.terms ctxt aas ^ "\"\n" ^
  "selected \"" ^ UnparseC.term ctxt (hd aas) ^ "\"\n" ^
	"with\n" ^
	"formals: " ^ UnparseC.terms ctxt formals ^ "\n" ^
	"actuals: " ^ UnparseC.terms ctxt actuals
fun trace_init ctxt metID =
  if Config.get ctxt LI_trace
  then tracing("@@@ program \"" ^ strs2str metID ^ "\"")
  else ();

fun assoc_by_type ctxt f aa prog met_id formals actuals =
  case filter (curry (fn (f, a) => type_of f = type_of a) f) aa of
    [] => raise ERROR (msg_miss_type ctxt prog met_id f formals actuals)
  | [a] => (f, a)
  | aas as (a :: _) => (writeln (msg_ambiguous ctxt prog met_id f aas formals actuals); (f, a));
(*
  fun assoc_formals_actuals: at "PIDE turn 11" ONLY syntax revised, NOT semantics
  Env.T ->         (* [] for building return Env.T         *)
  term list ->     (* changed during building return Env.T *)
  term list ->     (* changed during building return Env.T *)
  Proof.context -> (*                                      *)
  term ->          (* program code                         *)
  MethodC.id ->    (* for error msg                        *)
  term list ->     (* original value, unchanged            *)
  term list ->     (* original value, unchanged            *)
  Env.T            (* return Env.T                         *)
*)
\<close> ML \<open>
fun relate_args _ (f::_) [] ctxt prog met_id formals actuals =
    raise ERROR (msg_miss ctxt prog met_id "relate_args" f formals actuals)
  | relate_args env [] _ _ _ _ _ _ = env (*may drop Find?*)
  | relate_args env (f::ff) (aas as (a::aa)) ctxt prog met_id formals actuals = 
    if type_of f = type_of a 
    then relate_args (env @ [(f, a)]) ff aa ctxt prog met_id formals actuals
    else
      let val (f, a) = assoc_by_type ctxt f aas prog met_id formals actuals
      in relate_args (env @ [(f, a)]) ff (remove op = a aas) ctxt prog met_id formals actuals end
;
(*+*)relate_args: Env.T -> term list -> term list -> Proof.context -> term -> MethodC.id ->
    term list -> term list -> Env.T;
(*#------------------- un-hide local of init_pstate -----------------------------------------/*)

\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>(*//------------ step into init_pstate -----------------------------------------------\\*)
(*//------------------ step into init_pstate -----------------------------------------------\\*)
val (_, ctxt, i_model, met_id) = (prog_rls, ctxt, itms, mI);
"~~~~~ fun init_pstate , args:"; val (ctxt, i_model, met_id) =
    (ctxt, I_Model.OLD_to_TEST i_model, met_id);
    val (model_patt, program, prog, prog_rls, where_, where_rls) =
      case MethodC.from_store ctxt met_id of
        {model = model_patt, program = program as Rule.Prog prog, prog_rls, where_, where_rls,...} =>
          (model_patt, program, prog, prog_rls, where_, where_rls)
      | _ => raise ERROR ("init_pstate with " ^ MethodC.id_to_string met_id)

\<close> ML \<open>
    val return_of_max_variant = 
           of_max_variant model_patt i_model;
\<close> ML \<open>(*///----------- step into of_max_variant --------------------------------------------\\*)
(*///----------------- step into of_max_variant --------------------------------------------\\*)
"~~~~~ fun of_max_variant , args:"; val (model_patt, i_model) = (model_patt, i_model);

(*+*)i_model: I_Model.T_TEST;

    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (cnt_corrects) variants_separated
(*+*)val [3] = sums_corr;

    val sum_variant_s = arrange_args1 sums_corr (1, all_variants)
(*+*)val [(3, 1)] = sum_variant_s;

    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
(*+*)val 1 = max_variant;

    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
(*+*)val 3 = length i_model_max;

    val equal_descr_pairs =
      map (get_equal_descr i_model) model_patt
      |> flat
(*+*)val 3 = length equal_descr_pairs; (*only 1 variant in this test*)

\<close> ML \<open>
    val env_model = make_env_model equal_descr_pairs
    val equal_givens = filter (fn ((m_field, _), _) => m_field = "#Given") equal_descr_pairs
\<close> ML \<open>
(*+*)val ([], []) = (env_subst, env_eval)
\<close> ML \<open>
(*+*)if (equal_descr_pairs |> descr_pairs_to_string @{context}) = "[" ^
  "((#Given, (equality, e_e)), " ^
    "(1, [1], true ,#Given, (Cor_TEST equality (x + 1 = 2) , pen2str, Position.T))), " ^
  "((#Given, (solveFor, v_v)), " ^
    "(2, [1], true ,#Given, (Cor_TEST solveFor x , pen2str, Position.T))), " ^
  "((#Find, (solutions, v_v'i')), " ^
    "(3, [1], true ,#Find, (Cor_TEST solutions L , pen2str, Position.T)))]"
  then () else error "equal_descr_pairs CHANGED";
\<close> ML \<open>(*|||----------- contine of_max_variant ------------------------------------------------*)
(*|||----------------- contine of_max_variant ------------------------------------------------*)
    val subst_eval_list = make_envs_preconds equal_givens
    val (env_subst, env_eval) = split_list subst_eval_list

\<close> ML \<open>
val return_of_max_variant_step = (i_model_max, env_model, (env_subst, env_eval));
\<close> ML \<open>
(*+*) val "[\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\", \"\n(v_v'i', L)\"]"
  = env_model |>Subst.to_string @{context};
(*+*)if return_of_max_variant_step = return_of_max_variant then () else error "<>";
\<close> ML \<open>(*\\\----------- step into of_max_variant --------------------------------------------\\*)
(*\\\----------------- step into of_max_variant --------------------------------------------\\*)
val (_, env_model, (env_subst as [], env_eval as [])) = return_of_max_variant
 
\<close> ML \<open>(*||------------ continue init_pstate ------------------------------------------------\\*)
(*||------------------ continue init_pstate ------------------------------------------------\\*)
    val actuals = map snd env_model
\<close> ML \<open>
(*+*)val "[x + 1 = 2, x, L]" = actuals |> UnparseC.terms @{context}
(*+*)val [_, Free ("x", _), Free ("L", typ)] = actuals
\<close> ML \<open>
(*+*)val Type ("List.list", [Type ("HOL.bool", [])]) = typ
\<close> ML \<open>
    val formals = Program.formal_args prog
(*+*)val "[e_e, v_v]" = (formals |> UnparseC.terms @{context})

(*+*)val "minisubpbl e_e v_v =\n(let e_ea =\n       (Try (Rewrite_Set ''norm_equation'') #>\n        Try (Rewrite_Set ''Test_simplify''))\n        e_e;\n     L_La =\n       SubProblem\n        (''Test'', [''LINEAR'', ''univariate'', ''equation'', ''test''],\n         [''Test'', ''solve_linear''])\n        [BOOL e_e, REAL v_v]\n in Check_elementwise L_L {v_v. Assumptions})" =
  (prog |> UnparseC.term @{context})

\<close> ML \<open>
    val preconds = Pre_Conds.check_envs_TEST ctxt where_rls where_ (env_model, (env_subst, env_eval))

\<close> ML \<open>(*||------------ continue init_pstate ------------------------------------------------\\*)
(*||------------------ continue init_pstate ------------------------------------------------\\*)
    val ctxt = ctxt |> ContextC.insert_assumptions (map snd (snd preconds));
    val ist = Istate.e_pstate
      |> Istate.set_eval prog_rls
      |> Istate.set_env_true (relate_args [] formals actuals ctxt prog met_id formals actuals);
(*+*)                        (relate_args [] formals actuals ctxt prog met_id formals actuals);
(*+*)val "[\"\n(e_e, x + 1 = 2)\", \"\n(v_v, x)\"]" =
                             (relate_args [] formals actuals ctxt prog met_id formals actuals)
       |> Subst.to_string @{context}

val return_init_pstate_steps = (* = return_init_pstate*)
    (Istate.Pstate ist, ctxt, program)
\<close> ML \<open>(*\\------------ step into init_pstate -----------------------------------------------//*)
(*\\------------------ step into init_pstate -----------------------------------------------//*)
val (is, env, ctxt, prog) = return_init_pstate;

\<close> ML \<open>(*|------------- continuing do_next_Specify_Method -------------------------------------*)
(*|------------------- continuing do_next_Specify_Method -------------------------------------*)
\<close> ML \<open>(*\------------- step into do_next_Specify_Method ------------------------------------//*)
(*\------------------- step into do_next_Specify_Method ------------------------------------//*)
\<close> ML \<open>
val (_, ([(tac, _, _)], _, (pt, p))) = return_Step_do_next_Specify_Method; val Apply_Method ["Test", "squ-equ-test-subpbl1"] = tac;

(*[1], Frm*)val (_, ([(tac, _, _)], _, (pt, p))) = Step.do_next p ((pt, e_pos'), []); val Rewrite_Set "norm_equation" = tac

(*[1], Res*)val return_Step_do_next_Rewrite_Set = Step.do_next p ((pt, e_pos'), []);
\<close> ML \<open>(*/------------- step into do_next_Apply_Method --------------------------------------\\*)
(*/------------------- step into do_next_Apply_Method --------------------------------------\\*)
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p ,((pt, e_pos'), []));
\<close> ML \<open>
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

      Step.switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos))
  = (p_, (pt, ip));
      (*if*) Pos.on_specification ([], state_pos) (*else*);

        LI.do_next (pt, input_pos);
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) = (pt, input_pos);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
	      val ((ist, ctxt), sc) = LItool.resume_prog (p,p_) pt;

val return_LI_find_next_step = (*case*)
        LI.find_next_step sc (pt, pos) ist ctxt (*of*);
(*//------------------ step into LI.find_next_step -----------------------------------------\\*)
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as (pt, pos as (p, _))), (Istate.Pstate ist), ctxt) =
  (sc, (pt, pos), ist, ctxt);
(*.. this showed that we have ContextC.empty*)
(*\\------------------ step into LI.find_next_step -----------------------------------------//*)
val LI.Next_Step (ist, ctxt, tac) = return_LI_find_next_step;

        LI.by_tactic tac (ist, Tactic.insert_assumptions tac ctxt) ptp;
"~~~~~ fun by_tactic , args:"; val (tac_, ic, (pt, pos))
  = (tac, (ist, Tactic.insert_assumptions tac ctxt), ptp);
      val pos = next_in_prog' pos

 	    val (pos', c, _, pt) =
Solve_Step.add_general tac_ ic (pt, pos);
"~~~~~ fun add_general , args:"; val (tac, ic, cs)
  = (tac_, ic, (pt, pos));
 (*if*) Tactic.for_specify' tac (*else*);

Solve_Step.add tac ic cs;
"~~~~~ fun add , args:"; val ((Tactic.Rewrite_Set' (_, _, rls', f, (f', asm))), (is, ctxt), (pt, (p, _)))
  = (tac, ic, cs);
      val (pt, c) = Ctree.cappend_atomic pt p (is, ctxt) f 
        (Tactic.Rewrite_Set (Rule_Set.id rls')) (f', asm) Ctree.Complete
      val pt = Ctree.update_branch pt p Ctree.TransitiveB

val return =
      ((p, Pos.Res), c, Test_Out.FormKF (UnparseC.term ctxt f'), pt)
\<close> ML \<open>(*\------------- step into do_next_Apply_Method --------------------------------------//*)
(*\------------------- step into do_next_Apply_Method --------------------------------------//*)
val (_, ([(tac, _, _)], _, (pt, p))) = return_Step_do_next_Rewrite_Set

(* final test ... ----------------------------------------------------------------------------*)
(*+*)val ([2], Res) = p;
Test_Tool.show_pt_tac pt; (*[
([], Frm), solve (x + 1 = 2, x)
. . . . . . . . . . Apply_Method ["Test", "squ-equ-test-subpbl1"], 
([1], Frm), x + 1 = 2
. . . . . . . . . . Rewrite_Set "norm_equation", 
([1], Res), x + 1 + - 1 * 2 = 0
. . . . . . . . . . Rewrite_Set "Test_simplify", 
([2], Res), - 1 + x = 0
. . . . . . . . . . Check_Postcond ["sqroot-test", "univariate", "equation", "test"]]   ..INCORRECT
*)

\<close> ML \<open>
\<close>


section \<open>=====bieg Interpret/li-tool.sml =======================================================\<close>
ML \<open>
\<close> ML \<open>
(* Title:  Interpret/li-tool.sml
   Author: Walther Neuper 050908
   (c) copyright due to lincense terms.
*)
"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- fun implicit_take, fun get_first_argument -------------------------";
"----------- fun from_prog ---------------------------------------";
"----------- fun specific_from_prog ----------------------------";
"----------- fun de_esc_underscore -------------------------------";
"----------- fun go ----------------------------------------------";
"----------- fun formal_args -------------------------------------";
"----------- fun dsc_valT ----------------------------------------";
"----------- fun arguments_from_model ---------------------------------------";
"----------- fun init_pstate -----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";

val thy =  @{theory Isac_Knowledge};

\<close> ML \<open>
"----------- fun init_pstate -----------------------------------------------------------------";
"----------- fun init_pstate -----------------------------------------------------------------";
"----------- fun init_pstate -----------------------------------------------------------------";
(*
  This test is deeply nested (down into details of creating environments).
  In order to make Sidekick show the structure add to each
  *                    (*/...\*) and        (*\.../*)
  * a companion  > ML < (*/...\*) and > ML < (*\.../*)
  Note the wrong ^----^ delimiters.
*)
val fmz = ["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	     "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x", "GleichungsVariablen [c, c_2, c_3, c_4]",
	     "AbleitungBiegelinie dy"];
val (dI',pI',mI') = ("Biegelinie", ["Biegelinien"],
		     ["IntegrierenUndKonstanteBestimmen2"]);
val p = e_pos'; val c = [];
(*[], Pbl*)val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))]; val Model_Problem = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Traegerlaenge L" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Streckenlast q_0" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Biegelinie y" = nxt
\<close> ML \<open>
(*/---broken elementwise input to lists---\* )
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*\<rightarrow>Add_Relation "Randbedingungen [y 0 = 0]", ERROR MISSING step: M_b 0 = 0*)
                                        (*isa* ) val Add_Relation "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]" = nxt
                                        ( *isa2*) val Add_Relation "Randbedingungen [y 0 = 0]" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*\<rightarrow>Add_Relation "Randbedingungen [y L = 0, M_b 0 = 0, M_b L = 0]"*)
                                        (*isa*) val Specify_Theory "Biegelinie" = nxt
                                        (*isa2* ) val Add_Relation "Randbedingungen [y L = 0, M_b 0 = 0, M_b L = 0]" = nxt( **)
( *\---broken elementwise input to lists---/*)
\<close> ML \<open>
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Relation "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["Biegelinien"] = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["IntegrierenUndKonstanteBestimmen2"] = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "FunktionsVariable x" = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "GleichungsVariablen [c, c_2, c_3, c_4]" = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "AbleitungBiegelinie dy" = nxt

\<close> ML \<open>
(*[], Met*)val return_Add_Given_AbleitungBieg
                                = me nxt p c pt;
\<close> ML \<open> (*/------------ step into me_Add_Given_AbleitungBieg --------------------------------\\*)
(*/------------------- step into me_Add_Given_AbleitungBieg --------------------------------\\*)

"~~~~~ fun me , args:"; val (tac, p, _(*NEW remove*), pt) = (nxt, p, c, pt);
      val ctxt = Ctree.get_ctxt pt p
val ("ok", (_, _, ptp as (pt, p))) =
  	    (*case*) Step.by_tactic tac (pt, p) (*of*);

\<close> ML \<open>
        (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
\<close> ML \<open>
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) =
  (p, ((pt, Pos.e_pos'), []) );
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
val _ =
      (*case*) tacis (*of*);
        (*if*) probl_id = Problem.id_empty (*else*);

\<close> ML \<open>
           switch_specify_solve p_ (pt, ip);
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
       (*if*) Pos.on_specification ([], state_pos) (*then*);

\<close> ML \<open>
           specify_do_next (pt, input_pos);
\<close> ML \<open>
"~~~~~ fun specify_do_next , args:"; val (ptp as (pt, (p, p_))) = (pt, input_pos);
    val (_, (p_', tac)) = Specify.find_next_step ptp
    val ist_ctxt =  Ctree.get_loc pt (p, p_)
val Tactic.Apply_Method mI =
    (*case*) tac (*of*);

\<close> ML \<open>
  	    LI.by_tactic (Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty))
  	      ist_ctxt (pt, (p, p_'));
\<close> ML \<open>
"~~~~~ fun by_tactic , args:"; val ((Tactic.Apply_Method' (mI, _, _, _)), (_, ctxt), (pt, pos as (p, _))) =
  ((Tactic.Apply_Method' (mI, NONE, Istate.empty, ContextC.empty)), ist_ctxt, (pt, (p, p_')));
      val (itms, oris, probl) = case get_obj I pt p of (*STILL asms=[]*)
          PblObj {meth = itms, origin = (oris, _, _), probl, ...} => (itms, oris, probl)
        | _ => raise ERROR "LI.by_tactic Apply_Method': uncovered case get_obj"
      val {model, ...} = MethodC.from_store ctxt mI;
      val itms = if itms <> [] then itms else I_Model.complete oris probl [] model
;
(*+*)if (itms |> I_Model.to_string @{context}) = "[\n" ^
  "(1 ,[1] ,true ,#Given ,Cor Traegerlaenge L ,(l_l, [L])), \n" ^
  "(2 ,[1] ,true ,#Given ,Cor Streckenlast q_0 ,(q_q, [q_0])), \n" ^
  "(3 ,[1] ,true ,#Find ,Cor Biegelinie y ,(b_b, [y])), \n" ^
  "(4 ,[1] ,true ,#Relate ,Cor Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0] ,(r_b, [[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]])), \n" ^
  "(5 ,[1] ,true ,#Given ,Cor FunktionsVariable x ,(fun_var, [x])), \n" ^
  "(6 ,[1] ,true ,#Given ,Cor GleichungsVariablen [c, c_2, c_3, c_4] ,(vs, [[c, c_2, c_3, c_4]])), \n" ^
  "(7 ,[1] ,true ,#Given ,Cor AbleitungBiegelinie dy ,(id_der, [dy]))]"
(*+*)then () else error "init_pstate: initial i_model changed";
(*+*)if (itms |> I_Model.penv_to_string @{context}) = "[" ^ (*to be eliminated*)
(*1*)"(l_l, [L]), " ^
(*2*)"(q_q, [q_0]), " ^
(*3*)"(b_b, [y]), " ^
(*4*)"(r_b, [[y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]]), " ^
(*5*)"(fun_var, [x]), " ^
(*6*)"(vs, [[c, c_2, c_3, c_4]]), " ^
(*7*)"(id_der, [dy])]"
(*+*)then () else error "init_pstate: initial penv changed";

\<close> ML \<open>
    (*case*)
    LItool.init_pstate ctxt (I_Model.OLD_to_TEST itms) mI (*of*);
\<close> ML \<open>(*//------------ step into init_pstate -----------------------------------------------\\*)
(*//------------------ step into init_pstate -----------------------------------------------\\*)
"~~~~~ fun init_pstate , args:"; val (ctxt, i_model, met_id) = (ctxt, (I_Model.OLD_to_TEST itms), mI);
    val (model_patt, program, prog, prog_rls, where_, where_rls) =
      case MethodC.from_store ctxt met_id of
        {model = model_patt, program = program as Rule.Prog prog, prog_rls, where_, where_rls,...}=>
          (model_patt, program, prog, prog_rls, where_, where_rls)

\<close> ML \<open>
    val return_of_max_variant = 
           of_max_variant model_patt i_model;
\<close> ML \<open>(*///----------- step into of_max_variant --------------------------------------------\\*)
(*///----------------- step into of_max_variant --------------------------------------------\\*)
"~~~~~ fun of_max_variant , args:"; val (model_patt, i_model) = (model_patt, i_model);
\<close> ML \<open>
    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (cnt_corrects) variants_separated
    val sum_variant_s = arrange_args1 sums_corr (1, all_variants)
    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
    val equal_descr_pairs = map (get_equal_descr i_model) model_patt |> flat
;
\<close> ML \<open>
(*+*)if (equal_descr_pairs |> descr_pairs_to_string @{context}) = "[" ^
(*defined: in program+model--vvvv--,----------------------------------------- in problem ---vvv*)
  "((#Given, (Traegerlaenge, l_l)), (1, [1], true ,#Given, " ^
    "(Cor_TEST Traegerlaenge L , pen2str, Position.T))), " ^
  "((#Given, (Streckenlast, q_q)), (2, [1], true ,#Given, " ^
    "(Cor_TEST Streckenlast q_0 , pen2str, Position.T))), " ^
  "((#Given, (FunktionsVariable, fun_var)), (5, [1], true ,#Given, " ^
    "(Cor_TEST FunktionsVariable x , pen2str, Position.T))), " ^
  "((#Given, (GleichungsVariablen, vs)), (6, [1], true ,#Given, " ^
    "(Cor_TEST GleichungsVariablen [c, c_2, c_3, c_4] , pen2str, Position.T))), " ^
  "((#Given, (AbleitungBiegelinie, id_der)), (7, [1], true ,#Given, " ^
    "(Cor_TEST AbleitungBiegelinie dy , pen2str, Position.T))), " ^
  "((#Find, (Biegelinie, b_b)), (3, [1], true ,#Find, " ^
    "(Cor_TEST Biegelinie y , pen2str, Position.T))), " ^
  "((#Relate, (Randbedingungen, r_b)), (4, [1], true ,#Relate, " ^
    "(Cor_TEST Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0] , pen2str, Position.T)))]"
then () else error "of_max_variant: equal_descr_pairs CHANGED";

\<close> ML \<open>
    val return_make_env_model = make_env_model equal_descr_pairs;
\<close> ML \<open> (*////--------- step into make_env_model --------------------------------------------\\*)
(*////---------------- step into make_env_model --------------------------------------------\\*)
\<close> ML \<open>
"~~~~~ fun make_env_model , args:"; val (equal_descr_pairs) = (equal_descr_pairs);
\<close> ML \<open>
"~~~~~ fun xxx , args:"; val ((_, (_, id)), (_, _, _, _, (feedb, _))) = nth 4 equal_descr_pairs;
\<close> ML \<open>
"~~~~~ fun mk_env_model , args:"; val (id, (Model_Def.Cor_TEST ((descr, ts), _))) = (id, feedb);
\<close> ML \<open>
           handle_lists id (descr, ts);
"~~~~~ fun handle_lists , args:"; val (id, (descr, ts)) = (id, (descr, ts));
\<close> ML \<open>
(*+*)val xxx = ts |> UnparseC.terms @{context}
\<close> ML \<open>
  (*if*) Model_Pattern.is_list_descr descr (*then*);
\<close> ML \<open>
    (*if*) length ts > 1 (*then*);
\<close> ML \<open>
      (*if*) TermC.is_list (hd ts) (*then*);
\<close> ML \<open>
val return_handle_lists_step =
  [(id, TermC.list2isalist (Model_Pattern.typ_of_element descr) (map TermC.the_single ts))]
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
return_handle_lists_step
\<close> ML \<open>
(*+*)val xxx = return_handle_lists_step |> Subst.to_string @{context}
\<close> ML \<open>
(*+*)val "[\"\n(vs, [c, c_2, c_3, c_4])\"]"
  = return_handle_lists_step |> Subst.to_string @{context}
(*\\\\---------------- step into make_env_model --------------------------------------------//*)
\<close> ML \<open> (*\\\\--------- step into make_env_model --------------------------------------------//*)
    val env_model = return_make_env_model
(*+*)val "[\"\n(l_l, L)\", \"\n(q_q, q_0)\", \"\n(fun_var, x)\", \"\n(vs, [c, c_2, c_3, c_4])\", \"\n(id_der, dy)\", \"\n(b_b, y)\", \"\n(r_b, [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0])\"]"
  = env_model |> Subst.to_string @{context}
\<close> ML \<open> (*|||---------- contine of_max_variant ------------------------------------------------*)
(*|||----------------- contine of_max_variant ------------------------------------------------*)
    val equal_givens = filter (fn ((m_field, _), _) => m_field = "#Given") equal_descr_pairs
    val subst_eval_list = make_envs_preconds equal_givens
    val (env_subst, env_eval) = split_list subst_eval_list
\<close> ML \<open>
(*bieg*)val "[\"\n(l_l, L)\", \"\n(q_q, q_0)\", \"\n(fun_var, x)\", \"\n(vs, [c, c_2, c_3, c_4])\", \"\n(id_der, dy)\", \"\n(b_b, y)\", \"\n(r_b, [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0])\"]" = env_model |> Subst.to_string @{context}
(*bieg*)val "[]" = env_subst |> Subst.to_string @{context}
\<close> ML \<open>
val return_of_max_variant_step = (i_model_max, env_model, (env_subst, env_eval))
\<close> ML \<open>
(*+*)if return_of_max_variant_step = return_of_max_variant then () else error "<>"
\<close> ML \<open>(*\\\----------- step into of_max_variant --------------------------------------------//*)
(*\\\----------------- step into of_max_variant --------------------------------------------//*)
    val (_, env_model, (env_subst, env_eval)) = return_of_max_variant
\<close> ML \<open>
(*|------------------- contine init_pstate ---------------------------------------------------*)
    val actuals = map snd env_model
(*+*) val "[L, q_0, x, [c, c_2, c_3, c_4], dy, y, [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]]"
  = actuals |> UnparseC.terms @{context}
\<close> ML \<open>
    val formals = Program.formal_args prog
(*+*)val "[l_l, q_q, fun_var, b_b, r_b, vs, id_der]"
  = formals |> UnparseC.terms @{context}
(*+*)val 7 = length formals

\<close> ML \<open>
    val preconds =
      Pre_Conds.check_envs_TEST ctxt where_rls where_ (env_model, (env_subst, env_eval))
\<close> ML \<open>
    val ctxt = ctxt |> ContextC.insert_assumptions (map snd (snd preconds));
    val ist = Istate.e_pstate
      |> Istate.set_eval prog_rls
      |> Istate.set_env_true (relate_args [] formals actuals ctxt prog met_id formals actuals)
\<close> ML \<open>
(*+*)(relate_args [] formals actuals ctxt prog met_id formals actuals)
\<close> ML \<open>
val return_init_pstate = (Istate.Pstate ist, ctxt, program)
\<close> ML \<open>(*\\------------ step into init_pstate -----------------------------------------------//*)
(*\\------------------ step into init_pstate -----------------------------------------------//*)
\<close> ML \<open>(*\------------- step into me_Add_Given_AbleitungBieg --------------------------------//*)
(*\------------------- step into me_Add_Given_AbleitungBieg --------------------------------//*)
\<close> ML \<open> (*\------------ step into me_Add_Given_AbleitungBieg --------------------------------//*)
val (p,_,f,nxt,_,pt) = return_Add_Given_AbleitungBieg;
                                                 val Apply_Method ["IntegrierenUndKonstanteBestimmen2"] = nxt

\<close> ML \<open>
(* final test ... ----------------------------------------------------------------------------*)
(*+*)val ([], Met) = p
(*+*)val Apply_Method ["IntegrierenUndKonstanteBestimmen2"] = nxt

\<close> ML \<open>
\<close>

section \<open>=====eqsy refine_ori' [0 = - 1 * c_4 / - 1, 0 =\n (- 24 * c_4.., ..] ==================\<close>
ML \<open> (*\<longrightarrow> refine.sml*)
"----------- refine_ori' [0 = - 1 * c_4 / - 1, 0 =\n (- 24 * c_4.., ..] ------------------------";
"----------- refine_ori' [0 = - 1 * c_4 / - 1, 0 =\n (- 24 * c_4.., ..] ------------------------";
"----------- refine_ori' [0 = - 1 * c_4 / - 1, 0 =\n (- 24 * c_4.., ..] ------------------------";
(*overwrites NEW funs in Test_Theory ABOVE*)
open Refine
open M_Match
open Pre_Conds
(*overwrites NEW funs in Test_Theory ABOVE*)
(*
  refinement of the first eqsystem in Biegelinie, IntegrierenUndKonstanteBestimmen2;
  this example was the demonstrator;
  respective data are in ~/proto4/../exp_Statics_Biegel_Timischl_7-70.xml.
  Data for this test are from biegelinie-5.sml, --- me IntegrierenUndKonstanteBestimmen2 ALL ---
*)
\<close> ML \<open>
(*+*)val o_model = [
(1, [1], "#Given", @{term "equalities"},
  [@{term "[(0::real) = - 1 * c_4 / - 1]"},
   @{term "[(0::real) = (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +  - 1 * L \<up> 4 * q_0) / - 24]"},
   @{term "[(0::real) = c_2]"},
   @{term "[(0::real) = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]"}] ),
(*Const ("List.list.Cons", "real \<Rightarrow> real list \<Rightarrow> real list") $ Free ("c", "real") $ Const ("List.list.Nil", "real list"),*)
(2, [1], "#Given", @{term "solveForVars"},
  [@{term "[c]  ::real list"},
   @{term "[c_2]::real list"},
   @{term "[c_3]::real list"},
   @{term "[c_4]::real list"}] ),
(3, [1], "#Find",  @{term "solution"},  [@{term "ss'''::bool list"}] )]
;
val SOME ["normalise", "4x4", "LINEAR", "system"] =
           refine_ori @{context} o_model ["LINEAR", "system"];
\<close> ML \<open>
"~~~~~ fun refine_ori , args:"; val (ctxt, oris, pblID) =
  (@{context}, o_model, ["LINEAR", "system"]);

    val opt as SOME ["system", "LINEAR", "4x4", "normalise"]
    = app_ptyp (refin ctxt ((rev o tl) pblID) oris) pblID (rev pblID);
\<close> ML \<open>
(*
  app_ptyp works strangely, parameter passing is awkward.
  Present refin knows structure of Store.T, thus we bypass app_ptyp
*)
(*!*)val pblID = ["LINEAR", "system"];(**)
val return_refin as SOME ["system", "LINEAR", "LINEAR", "4x4", "normalise"] = (**)
           refin ctxt (rev pblID) oris (Store.get_node (rev pblID) pblID (get_pbls ()));
\<close> ML \<open>
"~~~~~ fun refin , args:"; val (ctxt, pblRD, ori, (Store.Node (pI, [py], pys)))
  = (ctxt, (rev pblID), oris, Store.get_node (rev pblID) pblID (get_pbls ()));
\<close> ML \<open>
      val {where_rls, model, where_, ...} = py: Problem.T
      val model = map (Model_Pattern.adapt_to_type ctxt) model
      val where_ = map (ParseC.adapt_term_to_type ctxt) where_;
\<close> ML \<open>
      (*if*) M_Match.match_oris ctxt where_rls ori (model, where_) (*then*);
\<close> ML \<open>
val return_refin as SOME ["system", "LINEAR"] = SOME (pblRD (** )@ [pI]( **))
\<close> ML \<open>
(*follow the trace created in parallel by writeln in Store.get_node and Refine.refin*)
(*!*)val pblID = ["4x4", "LINEAR", "system"];(**)
val return_refin as SOME ["system", "LINEAR", "4x4", "4x4", "normalise"] =
          refin ctxt (rev pblID) oris (Store.get_node (rev pblID) pblID (get_pbls ()));
\<close> ML \<open>
"~~~~~ fun refin , args:"; val (ctxt, pblRD, ori, (Store.Node (pI, [py], pys)))
  = (ctxt, (rev pblID), oris, Store.get_node (rev pblID) pblID (get_pbls ()));
\<close> ML \<open>
      val {where_rls, model, where_, ...} = py: Problem.T
      val model = map (Model_Pattern.adapt_to_type ctxt) model
      val where_ = map (ParseC.adapt_term_to_type ctxt) where_
\<close> ML \<open>
(*+*)val (**)true(** )false( **) = (*if*)
   M_Match.match_oris ctxt where_rls o_model (model, where_);
"~~~~~ fun match_oris , args:"; val (ctxt, where_rls, o_model, (model_pattern, where_)) =
  (ctxt, where_rls, o_model, (model, where_));
    val i_model = (flat o (map (chk1_ model_pattern))) o_model;

(*+*)val "[\n(1, [\"1\"], #Given, equalities, [\"[0 = - 1 * c_4 / - 1]\", \"[0 =\n (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n  - 1 * L \<up> 4 * q_0) /\n - 24]\", \"[0 = c_2]\", \"[0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]\"]), \n(2, [\"1\"], #Given, solveForVars, [\"[c]\", \"[c_2]\", \"[c_3]\", \"[c_4]\"]), \n(3, [\"1\"], #Find, solution, [\"ss'''\"])]"
  = o_model |> O_Model.to_string @{context};
(*+*)if "[\n" ^
  "(1 ,[1] ,true ,#Given ,Cor equalities\n [0 = - 1 * c_4 / - 1,\n  0 =\n  (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n   - 1 * L \<up> 4 * q_0) /\n  - 24,\n  0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2] ,(e_s, [[0 = - 1 * c_4 / - 1,\n 0 =\n (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n  - 1 * L \<up> 4 * q_0) /\n - 24,\n 0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]])), \n" ^
  "(2 ,[1] ,true ,#Given ,Cor solveForVars [c, c_2, c_3, c_4] ,(v_s, [[c, c_2, c_3, c_4]])), \n" ^
  "(3 ,[1] ,true ,#Find ,Cor solution ss''' ,(ss''', [ss''']))]"
 = (i_model |> I_Model.to_string @{context}) then () else raise error "i_model CAHNGED";
\<close> ML \<open>
(*+*)val "[\"(#Given, (equalities, e_s))\", \"(#Given, (solveForVars, v_s))\", \"(#Find, (solution, ss'''))\"]"
  = model_pattern |> Model_Pattern.to_string @{context}
(*+*)val "[Length e_s = 4, Length v_s = 4]" = where_ |> UnparseC.terms @{context}

    val mvat = I_Model.variables_TEST model_pattern (I_Model.OLD_to_TEST i_model)
    val complete = chk1_mis mvat i_model model_pattern;

    val (pb as true, (** )_( **)where_'(**)) =
 Pre_Conds.check_OLD ctxt where_rls where_ (model_pattern, I_Model.OLD_to_TEST i_model);
"~~~~~ fun check_OLD , args:"; val (ctxt, where_rls, pres, (model_patt, i_model)) =
  (ctxt, where_rls, where_, (model_pattern, I_Model.OLD_to_TEST i_model));
\<close> ML \<open>
(*+*)val [(true, xxx), (true, yyy)] = where_'
\<close> ML \<open>
(*+*)val "[Length\n [0 = - 1 * c_4 / - 1,\n  0 =\n  (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n   - 1 * L \<up> 4 * q_0) /\n  - 24,\n  0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2] =\n4, Length [c, c_2, c_3, c_4] = 4]"
 = where_' |> map #2 |> UnparseC.terms @{context}

      val (_, env_model, (env_subst, env_eval)) =
           of_max_variant model_patt i_model;
"~~~~~ fun of_max_variant , args:"; val (model_patt, i_model) = (model_patt, i_model);
\<close> ML \<open>
    val all_variants =
        map (fn (_, variants, _, _, _) => variants) i_model
        |> flat
        |> distinct op =
    val variants_separated = map (filter_variants' i_model) all_variants
    val sums_corr = map (cnt_corrects) variants_separated
    val sum_variant_s = arrange_args1 sums_corr (1, all_variants)
    val (_, max_variant) = hd (*..crude decision, up to improvement *)
      (sort (fn ((i, _), (j, _)) => int_ord (i, j)) sum_variant_s)
    val i_model_max =
      filter (fn (_, variants, _ , _ ,_) => member (op =) variants max_variant) i_model
    val equal_descr_pairs = map (get_equal_descr i_model) model_patt |> flat

    val env_model = make_env_model equal_descr_pairs
    val equal_givens = filter (fn ((m_field, _), _) => m_field = "#Given") equal_descr_pairs
\<close> ML \<open>
    val subst_eval_list =
           make_envs_preconds equal_givens;
\<close> ML \<open>
"~~~~~ fun make_envs_preconds , args:"; val (equal_givens) = (equal_givens);
\<close> ML \<open>
"~~~~~ fun xxx , args:"; val ((_, (_, id)), (_, _, _, _, (feedb, _))) = (nth 1 equal_givens);
\<close> ML \<open>
"~~~~~ fun discern_feedback , args:"; val (id, (Model_Def.Cor_TEST ((descr, ts), _))) =
  (id, feedb);
\<close> ML \<open>
val return_discern_typ as [] =
           discern_typ id (descr, ts);
\<close> ML \<open>
"~~~~~ fun discern_typ , args:"; val (id, (descr, ts)) = (id, (descr, ts));
\<close> ML \<open>
(*+*)val "[[0 = - 1 * c_4 / - 1], [0 =\n (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n  - 1 * L \<up> 4 * q_0) /\n - 24], [0 = c_2], [0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]]"
 = ts |> UnparseC.terms @{context}
\<close> ML \<open>
      val ts = if Model_Pattern.is_list_descr descr
        then if TermC.is_list (hd ts)
          then ts |> map TermC.isalist2list |> flat
          else ts
        else ts

(*+*)val "[0 = - 1 * c_4 / - 1, 0 =\n(- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n - 1 * L \<up> 4 * q_0) /\n- 24, 0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]"
 = ts |> UnparseC.terms @{context};
\<close> ML \<open>
  (*if*)  Model_Pattern.typ_of_element descr = HOLogic.boolT (*then*);
\<close> ML \<open>
(*+*)val false = all_lhs_atoms ts
(*-------------------- contine check_OLD -----------------------------------------------------*)
 
     val pres_subst = map (TermC.subst_atomic_all env_subst) where_;
\<close> ML \<open>
(*+*)if "[\"\n" ^
  "(e_s, [0 = - 1 * c_4 / - 1,\n 0 =\n (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n  - 1 * L \<up> 4 * q_0) /\n - 24,\n 0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2])\", \"\n" ^
  "(v_s, [c, c_2, c_3, c_4])\", \"\n(ss''', ss''')\"]"
 = (env_model |> Subst.to_string @{context}) then () else error "env_model CAHNGED";
\<close> ML \<open>
(*+*)val "[]" = env_eval |> Subst.to_string @{context} (*GOON \<rightarrow> []*)
\<close> ML \<open>
      val pres_subst_other = map (TermC.subst_atomic_all env_model) (map #2 pres_subst);
\<close> ML \<open>
      val full_subst = if env_eval = [] then pres_subst_other
        else map (TermC.subst_atomic_all env_eval) (map #2 pres_subst_other)
\<close> ML \<open>
      val evals = map (eval ctxt where_rls) full_subst
\<close> ML \<open>
val return_check_OLD = (foldl and_ (true, map fst evals), pres_subst_other)
\<close> ML \<open>
val return_refin as SOME ["system", "LINEAR", "4x4"] = SOME (pblRD(** ) @ [pI]( **))
\<close> ML \<open>
(*follow the trace created in parallel by writeln in Store.get_node and Refine.refin*)
(*!*)val pblID = ["normalise", "4x4", "LINEAR", "system"];(**)
val return_refin as SOME ["system", "LINEAR", "4x4", "normalise", "normalise"] =
          refin ctxt (rev pblID) oris (Store.get_node (rev pblID) pblID (get_pbls ()));
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====isa2 -> me IntegrierenUndKonstanteBestimmen2 ALL ====================================\<close>
ML \<open>
open Sub_Problem
\<close> ML \<open> (*\<rightarrow> biegelinie-4.sml OR NEW biegelinie-5.sml *)
"----------- me IntegrierenUndKonstanteBestimmen2 ALL ----------------------------------------";
"----------- me IntegrierenUndKonstanteBestimmen2 ALL ----------------------------------------";
"----------- me IntegrierenUndKonstanteBestimmen2 ALL ----------------------------------------";
(*
  This test is deeply nested (down into details of creating environments).
  In order to make Sidekick show the structure add to each
  *                    (*/...\*) and        (*\.../*)
  * a companion  > ML < (*/...\*) and > ML < (*\.../*)
  Note the wrong ^----^ delimiters.
*)
val fmz = ["Traegerlaenge L", "Streckenlast q_0", "Biegelinie y",
	     "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x", "GleichungsVariablen [c, c_2, c_3, c_4]",
	     "AbleitungBiegelinie dy"];
val (dI',pI',mI') = ("Biegelinie", ["Biegelinien"],
		     ["IntegrierenUndKonstanteBestimmen2"]);
val p = e_pos'; val c = [];
(*[], Pbl*)val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))]; val Model_Problem = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Traegerlaenge L" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Streckenlast q_0" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Biegelinie y" = nxt
(*/---broken elementwise input to lists---\* )
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*\<rightarrow>Add_Relation "Randbedingungen [y 0 = 0]", ERROR MISSING step: M_b 0 = 0*)
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*\<rightarrow>Add_Relation "Randbedingungen [y L = 0, M_b 0 = 0, M_b L = 0]"*)
( *\---broken elementwise input to lists---/*)
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Relation "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["Biegelinien"] = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["IntegrierenUndKonstanteBestimmen2"] = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "FunktionsVariable x" = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "GleichungsVariablen [c, c_2, c_3, c_4]" = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "AbleitungBiegelinie dy" = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["IntegrierenUndKonstanteBestimmen2"] = nxt
\<close> ML \<open>
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Streckenlast q_0" = nxt
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "FunktionsVariable x" = nxt
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Funktionen funs'''" = nxt
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["vonBelastungZu", "Biegelinien"] = nxt
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Biegelinien", "ausBelastung"] = nxt
(*[1], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Biegelinie y" = nxt
(*[1], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "AbleitungBiegelinie dy" = nxt
(*[1], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Biegelinien", "ausBelastung"] = nxt
\<close> ML \<open>
(*[1, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite ("sym_neg_equal_iff_equal", _) = nxt
(*[1, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite ("Belastung_Querkraft", _) = nxt
(*[1, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["named", "integrate", "function"]) = nxt
(*[1, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[1, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionTerm (- q_0)" = nxt
(*[1, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "integrateBy x" = nxt
(*[1, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "antiDerivativeName Q" = nxt
(*[1, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[1, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["named", "integrate", "function"] = nxt
(*[1, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["diff", "integration", "named"] = nxt
(*[1, 3], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["diff", "integration", "named"] = nxt
\<close> ML \<open>
(*[1, 3, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set_Inst (["(''bdv'', x)"], "simplify_Integral") = nxt
(*[1, 3, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set_Inst (["(''bdv'', x)"], "integration") = nxt
(*[1, 3, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["named", "integrate", "function"] = nxt
\<close> ML \<open>
(*[1, 3], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite ("Querkraft_Moment", _) = nxt
(*[1, 4], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["named", "integrate", "function"]) = nxt
(*[1, 5], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[1, 5], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionTerm (c + - 1 * q_0 * x)" = nxt
(*[1, 5], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "integrateBy x" = nxt
(*[1, 5], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "antiDerivativeName M_b" = nxt
(*[1, 5], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[1, 5], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["named", "integrate", "function"] = nxt
(*[1, 5], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["diff", "integration", "named"] = nxt
(*[1, 5], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["diff", "integration", "named"] = nxt
\<close> ML \<open>
(*[1, 5, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set_Inst (["(''bdv'', x)"], "integration") = nxt
(*[1, 5, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["named", "integrate", "function"] = nxt
\<close> ML \<open>
(*[1, 5], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite ("Moment_Neigung", _) = nxt
(*[1, 6], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite ("make_fun_explicit", _) = nxt
(*[1, 7], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["named", "integrate", "function"]) = nxt
(*[1, 8], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[1, 8], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionTerm (1 / - EI * (c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2))" = nxt
(*[1, 8], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "integrateBy x" = nxt
(*[1, 8], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "antiDerivativeName dy" = nxt
(*[1, 8], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[1, 8], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["named", "integrate", "function"] = nxt
(*[1, 8], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["diff", "integration", "named"] = nxt
(*[1, 8], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["diff", "integration", "named"] = nxt
\<close> ML \<open>
(*[1, 8, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set_Inst (["(''bdv'', x)"], "simplify_Integral") = nxt
(*[1, 8, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set_Inst (["(''bdv'', x)"], "integration") = nxt
(*[1, 8, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["named", "integrate", "function"] = nxt
\<close> ML \<open>
(*[1, 8], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["named", "integrate", "function"]) = nxt
(*[1, 9], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[1, 9], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionTerm\n (c_3 +\n  1 / (- 1 * EI) *\n  (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3))" = nxt
(*[1, 9], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "integrateBy x" = nxt
(*[1, 9], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "antiDerivativeName y" = nxt
(*[1, 9], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[1, 9], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["named", "integrate", "function"] = nxt
(*[1, 9], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["diff", "integration", "named"] = nxt
(*[1, 9], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["diff", "integration", "named"] = nxt
\<close> ML \<open>
(*[1, 9, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set_Inst (["(''bdv'', x)"], "integration") = nxt
(*[1, 9, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["named", "integrate", "function"] = nxt
(*[1, 9], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["vonBelastungZu", "Biegelinien"] = nxt
(*[1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["setzeRandbedingungen", "Biegelinien"]) = nxt
\<close> ML \<open>
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Funktionen\n [Q x = c + - 1 * q_0 * x, M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2,\n  dy x =\n  c_3 +\n  1 / (- 1 * EI) *\n  (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3),\n  y x =\n  c_4 + c_3 * x +\n  1 / (- 1 * EI) *\n  (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)]" = nxt
(*/---broken elementwise input to lists---\* )
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*\<rightarrow>Add_Relation "Randbedingungen [y 0 = 0]", ERROR MISSING step: M_b 0 = 0*)
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*\<rightarrow>Add_Relation "Randbedingungen [y L = 0, M_b 0 = 0, M_b L = 0]"*)
( *\---broken elementwise input to lists---/*)
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Randbedingungen [y 0 = 0, y L = 0, M_b 0 = 0, M_b L = 0]" = nxt
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Gleichungen equs'''" = nxt
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["setzeRandbedingungen", "Biegelinien"] = nxt
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Biegelinien", "setzeRandbedingungenEin"] = nxt
(*[2], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Biegelinien", "setzeRandbedingungenEin"] = nxt
\<close> ML \<open>
(*[2, 1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[2, 1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionEq\n (y x =\n  c_4 + c_3 * x +\n  1 / (- 1 * EI) *\n  (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4))" = nxt
(*[2, 1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val  Add_Given "substitution (y 0 = 0)" = nxt
(*[2, 1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "equality equ'''" = nxt
(*[2, 1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[2, 1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["makeFunctionTo", "equation"] = nxt
(*[2, 1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Equation", "fromFunction"] = nxt
(*[2, 1], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Equation", "fromFunction"] = nxt
\<close> ML \<open>
(*[2, 1, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["x = 0"] = nxt
(*[2, 1, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["y 0 = 0"] = nxt
(*[2, 1, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set "norm_Rational" = nxt
(*[2, 1, 3], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["makeFunctionTo", "equation"] = nxt
\<close> ML \<open>
(*[2, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["makeFunctionTo", "equation"]) = nxt
(*[2, 2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[2, 2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionEq\n (y x =\n  c_4 + c_3 * x +\n  1 / (- 1 * EI) *\n  (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4))" = nxt
(*[2, 2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "substitution (y L = 0)" = nxt
(*[2, 2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "equality equ'''" = nxt
(*[2, 2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[2, 2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["makeFunctionTo", "equation"] = nxt
(*[2, 2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Equation", "fromFunction"] = nxt
(*[2, 2], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Equation", "fromFunction"] = nxt
\<close> ML \<open>
(*[2, 2, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["x = L"] = nxt
(*[2, 2, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["y L = 0"] = nxt
(*[2, 2, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set "norm_Rational" = nxt
(*[2, 2, 3], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["makeFunctionTo", "equation"] = nxt
\<close> ML \<open>
(*[2, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["makeFunctionTo", "equation"]) = nxt
(*[2, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[2, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionEq (M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2)" = nxt
(*[2, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "substitution (M_b 0 = 0)" = nxt
(*[2, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "equality equ'''" = nxt
(*[2, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[2, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["makeFunctionTo", "equation"] = nxt
(*[2, 3], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Equation", "fromFunction"] = nxt
(*[2, 3], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Equation", "fromFunction"] = nxt
\<close> ML \<open>
(*[2, 3, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["x = 0"] = nxt
(*[2, 3, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["M_b 0 = 0"] = nxt
(*[2, 3, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set "norm_Rational" = nxt
(*[2, 3, 3], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["makeFunctionTo", "equation"] = nxt
\<close> ML \<open>
(*[2, 3], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["makeFunctionTo", "equation"]) = nxt
(*[2, 4], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
(*[2, 4], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionEq (M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2)" = nxt
(*[2, 4], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "substitution (M_b L = 0)" = nxt
(*[2, 4], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "equality equ'''" = nxt
(*[2, 4], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[2, 4], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["makeFunctionTo", "equation"] = nxt
(*[2, 4], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Equation", "fromFunction"] = nxt
(*[2, 4], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Equation", "fromFunction"] = nxt
\<close> ML \<open>
(*[2, 4, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["x = L"] = nxt
(*[2, 4, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["M_b L = 0"] = nxt
(*[2, 4, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set "norm_Rational" = nxt
(*[2, 4, 3], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["makeFunctionTo", "equation"] = nxt
(*[2, 4], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["setzeRandbedingungen", "Biegelinien"] = nxt

\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
(*[2], Res*)val return_Check_Postcond_setzeRandbedingungen = me nxt p c pt;
\<close> ML \<open> (*/------------ step into me_Check_Postcond_setzeRandbedingungen --------------------\\*)
(*/------------------- step into me_Check_Postcond_setzeRandbedingungen --------------------\\*)
"~~~~~ fun me , args:"; val (tac, p, _(*NEW remove*), pt) = (nxt, p, c, pt);
\<close> ML \<open>
      val ctxt = Ctree.get_ctxt pt p
\<close> ML \<open>
      val (pt, p) = 
  	    case Step.by_tactic tac (pt, p) of
  		    ("ok", (_, _, ptp)) => ptp
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
    (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
\<close> ML \<open>
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis)) = (p, ((pt, Pos.e_pos'), []));
\<close> ML \<open>
  (*if*) Pos.on_calc_end ip (*else*);
      val (_, probl_id, _) = Calc.references (pt, p);
\<close> ML \<open>                                                               
val _ =                                                              
      (*case*) tacis (*of*);
\<close> ML \<open>
        (*if*) probl_id = Problem.id_empty (*else*);
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
           switch_specify_solve p_ (pt, ip);
\<close> ML \<open>
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
\<close> ML \<open>
      (*if*) Pos.on_specification ([], state_pos) (*else*);
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
        LI.do_next (pt, input_pos)
\<close> ML \<open>
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) = (pt, input_pos);
\<close> ML \<open>
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
\<close> ML \<open>
	      val ((ist, ctxt), sc) = LItool.resume_prog pos pt;
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
val Next_Step (Pstate _, _, Subproblem' _) =
  (*case*) find_next_step sc ptp ist ctxt (*of*);
\<close> ML \<open>
"~~~~~ fun find_next_step , args:"; val ((Rule.Prog prog), (ptp as (pt, pos as (p, _))), (Pstate ist), ctxt)
  = (sc, ptp, ist, ctxt);
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
val Accept_Tac (Subproblem' _, _, _) =
  (*case*) scan_to_tactic (prog, (ptp, ctxt)) (Pstate ist) (*of*);
\<close> ML \<open>
"~~~~~ fun scan_to_tactic , args:"; val ((prog, cc), (Pstate (ist as {path, ...})))
  = ((prog, (ptp, ctxt)), (Pstate ist));
\<close> ML \<open>
  (*if*) path = [] (*else*);
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
val Accept_Tac (Subproblem' _, _, _) =
           go_scan_up (prog, cc) (trans_scan_up ist);
\<close> ML \<open>
"~~~~~ fun go_scan_up , args:"; val ((pcc as (sc, (_, ctxt))), (ist as {path, act_arg, found_accept, ...}))
  = ((prog, cc), (trans_scan_up ist));
\<close> ML \<open>
    (*if*) path = [R] (*root of the program body*) (*else*);
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
           scan_up pcc (ist |> path_up) (go_up ctxt path sc)
\<close> ML \<open>
"~~~~~ and scan_up , args:"; val ((pcc as (sc, cc as (_, ctxt))), ist, (Const (\<^const_name>\<open>Let\<close>(*1*), _) $ _))
  = (pcc, (ist |> path_up), (go_up ctxt path sc));
\<close> ML \<open>
        val (i, body) = check_Let_up ctxt ist sc
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
val Accept_Tac (Subproblem' _, _, _) =
  (*case*) scan_dn cc (ist |> path_up_down [R, D] |> upd_env i) body (*of*);
\<close> ML \<open>
"~~~~~ fun scan_dn , args:"; val (cc, ist, (Const (\<^const_name>\<open>Let\<close>(*1*), _) $ e $ (Abs (i, T, b))))
  = (cc, (ist |> path_up_down [R, D] |> upd_env i), body);
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
val Accept_Tac (Subproblem' _, _, _) =
  (*case*) scan_dn cc (ist |> path_down [L, R]) e (*of*);
\<close> ML \<open>
"~~~~~ fun scan_dn , args:"; val ((cc as (_, ctxt)), (ist as {eval, ...}), t (*fall-through*))
  = (cc, (ist |> path_down [L, R]), e);
\<close> ML \<open>
    (*if*) Tactical.contained_in t (*else*);
\<close> ML \<open>
val (Program.Tac prog_tac, form_arg) =
      (*case*) LItool.check_leaf "next  " ctxt eval (get_subst ist) t (*of*);
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
           check_tac cc ist (prog_tac, form_arg);
\<close> ML \<open>
"~~~~~ fun check_tac , args:"; val (((pt, p), ctxt), ist, (prog_tac, form_arg))
  = (cc, ist, (prog_tac, form_arg));
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
    val Subproblem ("Biegelinie", ["normalise", "4x4", "LINEAR", "system"]) =
    LItool.tac_from_prog (pt, p) prog_tac;
\<close> ML \<open>
"~~~~~ fun tac_from_prog , args:"; val ((pt, pos), intac)
  = ((pt, p), prog_tac);
\<close> ML \<open>
    val pos = Pos.back_from_new pos
    val ctxt = Ctree.get_ctxt pt pos
    val thy = Proof_Context.theory_of ctxt
\<close> ML \<open>
val (ptac as Const (\<^const_name>\<open>Prog_Tac.SubProblem\<close>, _) $ _ $ _) =
    (*case*) intac (*of*)
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
val Subproblem ("Biegelinie", ["normalise", "4x4", "LINEAR", "system"]) =
          fst (Sub_Problem.tac_from_prog (pt, pos) ptac) (*might involve problem refinement etc*)
\<close> text \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
val (Subproblem _, Subproblem' _) =
Sub_Problem.tac_from_prog (pt, pos) ptac;
\<close> ML \<open>
"~~~~~ fun tac_from_prog , args:"; val ((pt, p), (stac as Const (\<^const_name>\<open>Prog_Tac.SubProblem\<close>, _) $ spec' $ ags'))
  = ((pt, pos), ptac);
\<close> ML \<open>
      val (dI, pI, mI) = Prog_Tac.dest_spec spec'
(*+*)val ("Biegelinie", ["LINEAR", "system"], ["no_met"]) = Prog_Tac.dest_spec spec'

      val thy = common_sub_thy (Know_Store.get_via_last_thy dI, Ctree.root_thy pt);
      val init_ctxt = Proof_Context.init_global thy
	    val ags = TermC.isalist2list ags';
\<close> ML \<open>
	      (*if*) mI = ["no_met"] (*then*);
            val pors = (M_Match.arguments thy ((#model o (Problem.from_store init_ctxt)) pI) ags): O_Model.T
\<close> ML \<open>
(*+*)if (pors |> O_Model.to_string @{context}) = "[\n" ^
  "(1, [\"1\"], #Given, equalities, [\"[0 = - 1 * c_4 / - 1]\", " ^
                                    "\"[0 =\n (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n  - 1 * L \<up> 4 * q_0) /\n - 24]\", " ^
                                    "\"[0 = c_2]\", " ^
                                    "\"[0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]" ^
                                    "\"]), \n" ^
  "(2, [\"1\"], #Given, solveForVars, [\"[c]\", \"[c_2]\", \"[c_3]\", \"[c_4]\"]), \n" ^
  "(3, [\"1\"], #Find, solution, [\"ss'''\"])]" then () else error "pors CHANGED";
\<close> ML \<open>
		        val pI' = Refine.refine_ori' init_ctxt pors pI;
\<close> ML \<open>
(*+*)val ["normalise", "4x4", "LINEAR", "system"] = pI';
\<close> ML \<open> (*ERROR exception Empty raised (line 47 of "./basis/List.sml")*)
val return_tac_from_prog_step = (pI', pors (* refinement over models with diff.precond only *), 
		          (hd o #solve_mets o Problem.from_store init_ctxt) pI');
\<close> ML \<open>
                                 (Problem.from_store init_ctxt) pI'; (*.., solve_mets = [], ...*)
\<close> ML \<open>
val [["EqSystem", "normalise", "4x4"]] =
                   (#solve_mets o Problem.from_store init_ctxt) pI';
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open> (*|------------ contine me_Check_Postcond_setzeRandbedingungen ------------------------*)
(*|------------------- contine me_Check_Postcond_setzeRandbedingungen ------------------------*)
(*\------------------- step into me_Check_Postcond_setzeRandbedingungen --------------------//*)
\<close> ML \<open> (*\------------ step into me_Check_Postcond_setzeRandbedingungen --------------------//*)
\<close> text \<open>
val (p,_,f,nxt,_,pt) = return_Check_Postcond_setzeRandbedingungen;
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>

section \<open>===================================================================================\<close>
section \<open>=====  ============================================================================\<close>
ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close> ML \<open>
\<close>

section \<open>code for copy & paste ===============================================================\<close>
ML \<open>
"~~~~~ fun xxx , args:"; val () = ();
"~~~~~ and xxx , args:"; val () = ();
"~~~~~ from fun xxx \<longrightarrow>fun yyy \<longrightarrow>fun zzz , return:"; val () = ();
"~~~~~ continue fun xxx"; val () = ();
(*if*) (*then*); (*else*);   (*case*) (*of*);  (*return value*); (*in*) (*end*);
"xx"
^ "xxx"   (*+*) (*+++*) (*keep for continuing YYYYY*) (*isa*) (*isa2*) (**)
\<close> ML \<open> (*//----------- adhoc inserted n ----------------------------------------------------\\*)
 (*//----------------- adhoc inserted n ----------------------------------------------------\\*)
(*\\------------------ adhoc inserted n ----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- adhoc inserted n ----------------------------------------------------//*)

\<close> ML \<open> (*//----------- step into XXXXX -----------------------------------------------------\\*)
(*//------------------ step into XXXXX -----------------------------------------------------\\*)
(*keep for continuing YYYYY*)
\<close> ML \<open> (*------------- continuing XXXXX ------------------------------------------------------*)
(*-------------------- continuing XXXXX ------------------------------------------------------*)
(*kept for continuing XXXXX*)
(*-------------------- stop step into XXXXX --------------------------------------------------*)
\<close> ML \<open> (*------------- stop step into XXXXX --------------------------------------------------*)
(*\\------------------ step into XXXXX -----------------------------------------------------//*)
\<close> ML \<open> (*\\----------- step into XXXXX -----------------------------------------------------//*)

(*/------------------- check entry to XXXXX -------------------------------------------------\*)
(*\------------------- check entry to XXXXX -------------------------------------------------/*)
(*/------------------- check within XXXXX ---------------------------------------------------\*)
(*\------------------- check within XXXXX ---------------------------------------------------/*)
(*/------------------- check result of XXXXX ------------------------------------------------\*)
(*\------------------- check result of XXXXX ------------------------------------------------/*)
(* final test ... ----------------------------------------------------------------------------*)

\<close> ML \<open> (*//----------- inserted hidden code ------------------------------------------------\\*)
(*//------------------ inserted hidden code ------------------------------------------------\\*)
(*\\------------------ inserted hidden code ------------------------------------------------//*)
\<close> ML \<open> (*\\----------- inserted hidden code ------------------------------------------------//*)

\<close> ML \<open> (*//----------- build new fun XXXXX -------------------------------------------------\\*)
(*//------------------ build new fun XXXXX -------------------------------------------------\\*)
(*\\------------------ build new fun XXXXX -------------------------------------------------//*)
\<close> ML \<open> (*\\----------- build new fun XXXXX -------------------------------------------------//*)
\<close> ML \<open>
\<close>
end
