(* Quick introduction to ML, session 1 *)
theory ML1_Basics imports Isac.Isac_Knowledge begin

text\<open>This course follows the book:
J.D.Ullmann, Elements of ML Programming. Prenctice Hall 1998.
Contents:\<close>

section \<open>2.1 Expressions .. 2.1.5\<close>
ML \<open>
~1;
1 - 2;
1.2345;
"1234asdf";
1 < 2;
\<close>

section \<open>2.1.6 If-Then-Else\<close>
ML \<open>
val i = 3; (*"val" stores the "value" 7 into the "variable" i*)
if 5 < i 
then writeln "i is greater then 5"
else writeln "i is not greater than 5";
(*
if 5 < i 
then "i is greater then 5"
else 5
*)
\<close>

ML \<open>
if 5 < i 
then "i is greater then 5"
else "i is not greater than 5";
if 5 < i 
then 5 + 10
else i + 10;
val x = if 5 < i 
  then "i is greater then 5"
  else "i is not greater than 5";
\<close>

section \<open>2.4 Tuples and Lists\<close>
ML \<open>
val t = (4, 5.0 + 1.0, "six", 1 < 2);
val (a, _, _, d) = (4, 5.0 + 1.0, "six", 1 < 2); (*pattern matching*)
\<close>
ML \<open>
val l = [1, 2, 3, 4, 5, 6, 7];
1 :: (2 :: (3 :: [])); (* list constructor "::"*)
val l1 = 0 :: l;
val fi :: _ = l1;
\<close>

end
